Microsoft Dynamics® GP 2013 Modifier Help

Basics

Getting Started with the Modifier
The Modifier Interface

Modifying Forms

Selecting Forms to Modify
Modifying Windows
Modifying Scrolling Windows
Modifying Menus
Adding New Fields

Global Modifications

Data Types
Formats
Global Fields
Pictures and Native Pictures
Strings
Messages

Storing and Accessing Modifications

Storing Modifications
Accessing Modifications
Packaging Modifications

Reference

Windows in Modifier
Glossary

Documentation Feedback


Basics

This portion of the documentation contains basic information you should know before you begin using the Modifier. The following topics are discussed:

  • Getting Started with the Modifier describes the types of modifications you can make with the Modifier, the terminology used in the product, and how modifications are stored. It describes how to start the Modifier.
  • The Modifier Interface describes the Modifier’s interface.


Getting Started with the Modifier

Before you begin working with the Modifier, you should have a basic understanding of the types of modifications you can make, terminology used in the Modifier, and how modifications are stored. Information is divided into the following sections:

  • Types of modifications
  • Terminology
  • Storing modifications
  • Starting the Modifier


Types of modifications

You can use the Modifier to make three basic types of modifications: modifying the appearance of windows, making global changes to the interface, and adding new controls.

Modifying windows

With the Modifier, you can change the appearance of individual windows in the accounting system. This allows you to customize your system to the way you work. For instance, a common window modification is hiding fields that you won’t be using. Another common modification is changing the order in which the focus moves from field to field to reflect the way you enter data into the system.

Making global interface changes

The Modifier also allows you to make changes that will be reflected throughout the entire interface. For example, most of the strings that are displayed in the interface can be modified. If you were to modify the string “ZIP Code” and change it to be “Postal Code”, the change would be seen in every place the string “ZIP Code” was used.

Adding new fields

You can also use the Modifier to add new fields to windows in the accounting system. This capability is designed primarily for users who also use Visual Basic® for Applications (VBA), Visual Studio® Tools for Microsoft Dynamics GP, or the Continuum API to further customize Microsoft Dynamics GP.


Terminology

To get the most benefit from the Modifier, you need to understand the structure of an application like Microsoft Dynamics GP that is written in Microsoft® Dexterity. The interface is composed of windows and forms.

Windows

A window is the work area used to enter and display information in an application. Windows in a Dexterity-based application are the actual windows you see when you run the application.

Forms

A form is a collection of windows, menus and other resources that function together for a common purpose. For example, four windows work together to handle customer information. These windows are:

  • Customer Maintenance
  • Customer Maintenance Options
  • Customer Account Maintenance
  • Display Credit Limit Warning

Because they work together, these windows are grouped into a form named RM_Customer_Maintenance.

Forms are typically named based on the type of action the user is performing. Every window in a Dexterity-based application is part of a form. When you use the Modifier to work with window, you must first find and open the form that contains it.


Storing modifications

All changes and additions you make using the Modifier are stored in the forms dictionary for the application. By storing the new and modified resources in a separate dictionary, the integrity of the system can be maintained. For example, the following illustration shows the dictionary for Microsoft Dynamics GP and its associated forms dictionary.

You’ll learn more about the forms dictionary in Storing Modifications.


Starting the Modifier

To begin using the Modifier, log into the accounting system. If you’re using Microsoft Dynamics GP in a multiuser environment, verify that no other users are in the system before you use the Modifier. Then perform the following steps:

  1. Start the Modifier.

From the main Dynamics GP window:
In the Microsoft Dynamics GP menu, choose Tools >> Customize >> Modifier.

From individual task windows:
In the Tools menu, choose Customize >> Modifier.

If the Modifier item is dimmed, the Modifier hasn’t been registered or you have not been granted access through system security. Refer to the installation instructions included with Microsoft Dynamics GP for information about registering the Modifier. Refer to Accessing Modifications for more information about setting access to the Modifier.

  2. Select the product to modify.

If you’re using additional products that integrate with Microsoft Dynamics GP, the following window will appear when you start the Modifier.

Select the product you want to modify, then click OK. If Microsoft Dynamics GP is the only product available, this window won’t appear.


The Modifier Interface

This portion of the documentation describes the basic elements of the Modifier interface. It is divided into the following sections:

  • The Modifier main window and toolbar
  • Menus
  • Windows
  • Standard buttons


The Modifier main window and toolbar

When you start the Modifier, the Modifier’s main window and toolbar appear. The toolbar appears across the top of the main window. Each button that appears represents a fundamental resource that you can view or edit. The following table describes each button.

Button | Description
 | Opens the Data Types window, where you can view or edit existing data types.
 | Opens the Fields window, where you can view a list of fields in the application.
 | Opens the Forms window, where you can view a list of the modified forms in the application. You will also use this window to create new modified forms.


Menus

The following items are available in the Modifier menu bar.

File: Generate Resource Reports

This menu item prints a resource report for the application. The resource report is a text file that lists all resources in the current dictionary, their internal resource IDs and any resources associated with the listed resource. When you choose Generate Resource Reports, a dialog box will appear and allow you to name the report and select its location.

File: Print Setup

This menu item opens the printer setup dialog box. This dialog box allows you to configure the currently selected printer.

File: Process Monitor

This menu option opens the Process Monitor window. This window displays activity for tasks that you choose to process in the “background” within your application.

File: Microsoft Dynamics GP

Choosing the menu item allows you to exit the Modifier and return to the main application.

File: Table/Field/Window Descriptions

These menu items open forms in the Resource Descriptions tool. This tool displays information about all the tables, fields and windows used in the current dictionary.

File: Exit

This menu item allows you to exit the application.

Edit: Undo

This menu item will undo the last keyboard entry in an editable field. It will also undo field movement and sizing in a layout window, but not the addition or removal of fields, text or graphics from a layout window.

Edit: Cut/Copy/Paste

These menu items allow you to copy text or graphics to the Clipboard, then paste it in a different location. You cannot cut, copy or paste fields.

Edit: Clear

This menu item allows you to remove text from an editable field, or remove selected items from the layout area.

Edit: Select All

This menu item allows you to select the entire entry in a field, or all items in the layout area for a window, report or scrolling window.

Macro: (all)

The items available from the Macro menu allow you to record and play macros.

Resources: (all)

The items in the Resources menu allow you to access the various resources in the application. Resources available from this menu include all resources accessed from the toolbar, as well as other resources (such as formats and messages).

Windows:

This menu displays a list of the windows currently open. Selecting a window from this menu makes the window active.

Help: Lookup

This menu item opens any lookup window for the current field.

Help: Contents

This menu item displays the contents topic for the Modifier online help.

Help: Search for Help On

This menu item displays the search window for the help system, allowing you to search the Modifier online help.

Help: Window Help

This menu item displays help for the current window in the Modifier.

Help: About

This menu item displays the About window for the main application.


Windows

The Modifier uses several types of windows. Review the following descriptions to learn how each is used.

Resource list windows

Resource list windows display a list of resource names for a given resource type. To display a resource list window, click a button in the Modifier toolbar or choose a resource from the Resources menu. When the window appears, select a resource name and click Open to display its definition window.

The following illustration shows the Formats resource list window.

Definition windows

Definition windows allow you to customize individual resources in an application. For example, you will use the Format Definition window to customize how data is displayed in fields.

Layout window

You will use the Layout window to customize the appearance of windows in the application. The Layout window uses a graphics metaphor you may already be familiar with: an assortment of tools you can use for drawing and creating objects; a built-in grid that allows easy alignment of objects on the window; moveable objects in a layout like object-oriented drawing programs; and standard cut-copy-and-paste techniques so you can import graphics you create in other applications.

The Toolbox is available whenever the Layout window is open. It contains tools you will use to add objects to the layout. The Properties window is used to specify the characteristics of windows, fields and drawn items when you’re customizing a window layout.


Standard buttons

The following buttons are used throughout the Modifier:

Button | Description
 | Saves changes and closes the current window.
 | Closes the current window without saving the changes to the window.
 | Allows you to save information for the current window without closing the window.
 | Creates a new resource.
 | Opens the selected resource and displays its definition.
 | Deletes the selected resource.
 | Allows you to insert items in a list, such as fields into a table definition.
 | Allows you to remove items from a list, such as the static text values in a list box.
 | The lookup button opens another window, allowing you to select a value to return to the current field. Typically, clicking the lookup button displays a list of resources. One of these resources can be selected and have its value returned to the current field.


Modifying Forms

This portion of the documentation contains information about making modifications to forms. The following topics are discussed:

  • Selecting Forms to Modify explains how to make modifications to forms and windows.
  • Modifying Windows describes modifications you can make to windows.
  • Modifying Scrolling Windows describes modifications you can make to scrolling windows.
  • Modifying Menus explains how to modify menus.
  • Adding New Fields explains how to add new controls to windows.


Selecting Forms to Modify

Most of the modifications you make will be to forms or to the windows contained in those forms. Before you can make modifications, you must first locate the form to modify. This portion of the documentation explains how to do this. The information is divided into the following sections:

  • Finding a form name
  • Creating a modified form


Finding a form name

To modify a form, you need to know its name. You can find a form’s name using the Window Descriptions window, which is part of the Resource Descriptions tool. Use the following steps to find a form’s name.

  1. Find the name of a window you want to modify.

In Microsoft Dynamics GP, open a window that you want to modify. Note the window title. You will use this name to find out which form the window is part of. For example, the following illustration shows the window title for the Customer Maintenance window.

  2. Open the Window Descriptions window.

If you are in Microsoft Dynamics GP, open the Window Descriptions window by pointing to Resource Descriptions in the Tools menu, then choosing Windows. If you are already in the Modifier, choose Window Descriptions from the File menu.

  3. Locate the window.

In the Window Descriptions window, set the Product, Series and View By fields to locate the window. For example, to locate the Customer Maintenance window in Microsoft Dynamics GP, the product is Microsoft Dynamics GP and the series is Sales. Since you know the window display name (title), set the View By field to sort windows by the Window Display Name. Now you can locate the window name in the list.

  4. Find the form name.

Once you have found the window display name in the list, you can find the name of the form the window is part of. Continuing the example, the Customer Maintenance window is part of the RM_Customer_Maintenance form.


Creating a modified form

After you know the name of the form that contains the items you want to modify, start the Modifier. Then perform the following steps to create a modified version of the form.

  1. Create a new modified form.

If the Modified Forms window isn’t open, click the Forms button on the toolbar to display the list of Modified forms. Then click New to create a new modified form.

A window will appear, allowing you to select a form to modify.

  2. Select the form to modify.

From the window that appears, select the form that you want to modify, then click OK.

The Form Definition window will appear for the form you selected. The name of the form will also be added to the Modified Forms list. You can then begin making modifications.

A copy of the form you selected to modify was added to the Forms dictionary, allowing you to make modifications to it. In Storing and Accessing Modifications, you will learn more about how modified forms are stored and accessed.

If you simply want to modify a window in Microsoft Dynamics GP, you can save several steps. First, display the window you want to modify. Then point to Customize in the Tools menu and choose Modify Current Window. The Modifier will start, the form that contains the window will be added to the list of modified forms, and the layout for the window will be displayed.


Modifying Windows

Changing the appearance of windows is the most common modification made with the Modifier. This portion of the documentation provides detailed information about how to modify windows. It is divided into the following sections:

  • Opening a window layout
  • The Toolbox
  • The layout area
  • The layout grid
  • The Properties window
  • Window properties
  • Field properties
  • Drawn object properties
  • Previewing a window
  • Setting the tab sequence
  • Positioning the window
  • Adding fields to the window
  • Adding pictures
  • Linking fields to prompts
  • Resizing windows
  • Auto-complete
  • Linking fields to format fields


Opening a window layout

To open the layout for a window, open the Form Definition window for the form that contains the window. Click the Windows tab to display a list of windows for the form. Select a window and click Open.

If you are viewing the window you want to modify, you can point to Customize in the Tools menu and choose Modify Current Window. The Modifier will start, the form that contains the window will be added to the list of modified forms, and the layout for the window will be displayed.

The Layout window and Toolbox use a graphics metaphor you may already be familiar with: an assortment of tools you can use for drawing and creating text objects; a built-in grid that allows easy alignment of objects on the window; moveable objects in a layout like object-oriented drawing programs; and standard cut-copy-and-paste techniques so you can import graphics you create in other applications.

Changes you make to windows are saved only when the Layout window is closed. Save your work often by closing the Layout window and then reopening it to continue modifying the window.


The Toolbox

To add and manipulate objects in the Layout window, use tools from the Toolbox. The following tools are available:

Tool | Name | Use
 | Arrow tool | Select, resize and move objects in the window layout. Objects highlighted by the arrow tool can be dragged into position in the layout area.
 | Text tool | Add text objects to the layout area. Select the text tool, then click in the appropriate location to type text in the layout.
 | Picture tool | Place pictures from the picture library in the layout area. Select the picture tool, then click the mouse in the desired location in the layout area; the Pictures window will appear. Select a picture and click OK.
 | Line tool | Add lines to the layout area.
 | Shape tool | Add rectangles, circles and other shapes to the layout area.

The toolbox also contains tools you can use to add new fields to a window. Adding new fields is described in Adding New Fields.

Tool | Name | Tool | Name
 | Push button tool |  | Drop-down list tool
 | Combo box tool |  | List box tool
 | Multi-select list tool |  | Big text tool
 | String tool |  | Integer tool
 | Currency tool |  | Date tool
 | Time tool |  | Visual switch tool
 | Horizontal list box tool |  | Radio group tool
 | Radio button tool |  | Check box tool
 | Progress indicator tool |  |

Clicking the Arrange tab in the Toolbox displays additional tools used to align, resize or tile fields in the window. These tools are described in the following table.

Category | Tool | Name | Use
Align |  | Align to Top | Aligns the selected objects with the top object in the group.
 |  | Align to Left | Aligns the selected objects with the leftmost object in the group.
 |  | Align to Right | Aligns the selected objects with the rightmost object in the group.
 |  | Align to Bottom | Aligns the selected objects with the bottom object in the group.
Size |  | Size to Shortest | Shrinks the selected objects to the height of the shortest object in the group.
 |  | Size to Narrowest | Shrinks the selected objects to the width of the narrowest object in the group.
 |  | Size to Widest | Enlarges the selected objects to the width of the widest object in the group.
 |  | Size to Tallest | Enlarges the selected objects to the height of the tallest object in the group.
 |  | Size to Default | Resizes the field to its default size, based upon how the visual properties for the field are set.
Tile |  | Tile Horizontally | Tiles the selected objects horizontally. The value in the Space field specifies the space between objects.
 |  | Tile Vertically | Tiles the selected objects vertically. The value in the Space field specifies the space between objects.

Arranging objects can’t be undone. Be sure to save your window layout before arranging objects. If you aren’t satisfied with the result of an arrangement, you can close the window without saving the changes.

The position and size coordinates for the currently-selected object are displayed at the bottom of the Toolbox. Use these values to accurately position and size objects.


The layout area

The layout area is where you add fields, controls, graphics and text used by the window. This area represents the size of the window as it will appear at runtime, exclusive of native operating system controls such as title and scroll bars. To change the size of the window, drag the resize handles to adjust the width and height of the window.

The layout area doesn’t display controls that are specific to the operating system, such as scroll bars, resize boxes, minimize controls and title bars. Instead, operating system elements are created automatically.

It’s important to remember that items appearing in the layout area can look somewhat different than how they will appear at runtime. At runtime, all objects added to the layout area will appear in the window drawn properly.

Use the Show Field Names and Show Invisible Fields items in the Layout menu to specify how fields will be displayed in the layout window. If you mark the Show Field Names menu item, fields will show their field names, rather than their normal display characteristics. If you choose not to show field names, fields will display much like they do at runtime. The following table shows how several fields appear in the layout and how they appear at runtime:

Showing field names | Not showing field names | At runtime

If you mark the Show Invisible Fields item in the Layout menu, those fields whose Visible property is set to false will be displayed in the layout. Invisible fields are typically used to store values used by Microsoft Dynamics GP. They aren’t visible when the accounting system is running.

Each object in the window layout can be selected with the arrow tool, then dragged to a different position in the layout area. You also can move selected graphics, text or fields in front of or behind other objects by choosing Send To Front or Send To Back from the Layout menu.


The layout grid

The layout window has a grid that’s activated automatically when you open the window. When the grid is active, a check mark appears next to the Grid item in the Layout menu. Objects you add to the layout area will be aligned to the grid automatically, but existing objects in the layout area won’t be aligned to the grid. To align existing object to the grid, be sure the grid is active, then select the objects with the arrow tool and choose Align To Grid from the Layout menu.

It’s a good idea to use the layout grid when adding or rearranging items in the layout area, so items will be aligned automatically. If you want to display the grid in the layout area, choose Show Grid from the Layout menu. To display the grid behind objects in the layout window, choose Grid to Back. To deactivate the grid, choose Grid from the menu to remove the check mark.

You can use the arrow keys to move selected items in the window one pixel at a time, regardless of whether the grid is turned on.


The Properties window

The Properties window is used to set several characteristics of the window and the objects in the window. To display the properties for the window, select Properties from the Layout menu. If it isn’t already open, the Properties window will appear.

Select an object in the layout area and click the tab indicating which type of property you want to view. Click the Object or Visual tab, depending on the type of property you want to view. To set a property, select it in the list and then change its value in the settings box.

Setting the property value involves choosing a value from a drop-down list, typing a value, or using a lookup. Some properties listed can’t have their values changed.

Property type | Description
 | Some properties are set using a drop-down list.
 | Some properties have the value entered directly.
 | Some properties use a lookup to retrieve values.
 | Some properties can’t be set.

Double-clicking a property in the properties list is a shortcut to setting its value. For instance, double-clicking a property whose value is set with a drop-down list will set the property to the next value in the list.


Window properties

To view window properties, be sure the Properties window is open. Select the arrow tool from the Toolbox and click in the layout window outside of the window’s area to select the window. The window is selected when resize handles appear on its perimeter. The following table lists the window properties. Asterisks indicate the properties that can be changed using the Modifier.

Object property | Description
AutoLinkTable | Indicates the table auto-linked to the window. You can add fields from the auto-linked table to the window.
AutoOpen | If set to true, the window opens automatically when the form opens. By default, this value is set to true.
CloseBox* | If set to true, the close box on the window will be active.
HelpContextID | Lists the help context ID value for the window.
Name | The name of the window. This name is used to refer to the window in scripts.
Resizeable* | If set to false, the window cannot be resized by the user. If set to true-automatic, the window can be resized and the appropriate fields will be resized automatically. If set to true-per field, the window can be resized, but the resize characteristics must be specified for each individual field.
Title* | The name that is displayed in the title bar of the window.
WindowID | Lists the resource ID of the window.
WindowType | Indicates whether the window is a primary window, modal dialog, modeless dialog, wizard, lookup, toolbar, palette, or internal.

Visual property | Description
BackColor* | If set to true, sets the background area of the window to the window background color specified by the operating system. If set to false, the background of the window will be white.
ControlArea* | If set to true, a band called the control area will be displayed across the top of the window.
Position-Left* | Indicates the position of the left edge of the window, measured in pixels from the left edge of the screen.
Position-Top* | Indicates the position of the top edge of the window, measured in pixels from the bottom edge of the toolbar.
Size-Height* | Indicates the window height, measured in pixels.
Size-Width* | Indicates the window width, measured in pixels.


Field properties

The following table lists the field properties. Asterisks indicate the properties that can be changed using the Modifier.

Object property

Description

AutoComplete

For string fields, specifies whether the field will use the auto-complete capability. If this property is set to true, the contents of the field will automatically be completed as the user types, based on a list of values associated with the field.

AutoCopy

Specifies whether information is automatically transferred between the field and the corresponding field in the table. If set to false, the field will be unaffected by processing that copies information to or from the field.

Cancel

If this property is set to true, the process associated with this field will be run when the user presses esc while the window containing the field is active. This property is typically set to true for a Cancel push button field. This property is available only for push button fields.

DataType

Indicates the data type used for the field.

Default

If this property is set to true, the process associated with this field will be run when the user pressing the enter key or double-clicking a list box or scrolling window with the DefaultDblClick property set to true. The Default property is typically set to true for an OK or Save push button field. This property is available only for push buttons.

DefaultDblClick

Setting this property to true allows the user to double-click a list box field to accomplish the action of selecting an item and clicking the push button whose Default property is set to true.

DisableLookup*

If set to true, prevents a lookup form associated with the field from opening when a user chooses the Lookup menu item.

DraggableCols

Applies only when the list view is displayed in report view mode. True indicates the user can reorder columns by dragging them. False indicates columns can’t be reordered by the user.

Editable*

Specifies whether the user can edit the contents of the field.

EditMode*

For text fields, this property specifies how text fields can be edited. If set to DisplayOnly, the text field can’t be edited. If set to Editable, the field can be edited. If set to SelectOnly, text can be selected, but not changed.

EndTransaction

When set to true, this property indicates that all processing for a transaction will be completed when the button is clicked. This property is available only for push button fields.

Field

Indicates the field being used and allows you to view characteristics of the field definition.

FieldID

Indicates the resource ID of the field.

FieldType

Indicates whether the field is a global field or a local field.

HelpContextID

Lists the help context ID value for the field.

Hyperspace

When set to true, the push button can be clicked without performing any pending processing for the currently-focused field. Only the process for the push button that was clicked will be run. Typically, this property is set to true for Cancel buttons. It is available only for push button fields.

LinkedFormat

Lists the format field linked to the current field.

LinkedLookup

Lists the lookup field (typically a push button) linked to the current field.

LinkedPrompt

List the prompt linked to the field.

MultiSel

True indicates multiple items can be selected in the list view. False indicates only one item can be selected.

Password*

If set to true for string fields, the field will display Xs instead of the data entered in the field. This is typically used for password fields.

Required*

Specifies whether the field is required for the record or transaction to be saved correctly. Set this value to true when you want to be sure the user enters a value in this field. Also, if this property is set to true, and the Show Required Fields menu item is selected, any prompt linked to the field will be displayed according to the color and style specified in the User Display Preferences window.

The Required property can’t be unmarked for fields already marked as required for the original form. However, the fields you set as required can be unmarked at a later time.

SavedOnRestart*

If set to true, causes the field to keep the value that was last entered in it, when the form or window is restarted. If set to false, a restart will clear the field.

ScrollBars*

If set to true, a text field will have scroll bars. If set to false, no scroll bars will be displayed.

SetChangeFlag*

Specifies whether changes to a field’s value will set the change flag for the form or window. If set to true, the change flag will be set when the contents of the field change. If set to false, the change flag won’t be set.

SortMethod

Specifies how items in list view or tree view fields are sorted.

TabStop*

Specifies whether to include a window field in the tab sequence. If set to true, the window field will be in the tab sequence.

Tooltip*

Specifies the tooltip that will be displayed for the field.

UseUniqueHelp

If set to true, a unique HelpContextID will be generated for this instance of the field. If set to false, the same HelpContextID will be generated for all instances of this field in the application.

VisibleItems*

For drop-down list and combo box fields, specifies the maximum number of items displayed when the list is displayed in the dropped position.

WordWrap*

For text fields, specifies whether text will wrap.

Visual property

Description

Alignment*

Specifies whether the item is left-, center- or right-aligned.

AltLineColor*

If set to true, alternate lines of the list view will appear with a different color.

Appearance*

For edit fields, specifies what type of border the field will have. For push buttons, button drop lists and push button-style check boxes, setting this property to 3D Highlight causes the button to have a flat appearance until the mouse pointer passes over the button.

BackColor*

Specifies the background color of the field.

Border*

If set to true, a border is drawn around the field.

Direction*

For progress indicator fields, indicates the direction the bar will move in the progress indicator.

DropIndicator*

For button drop list fields, specifies whether the drop indicator will be displayed.

DropPosX*

For button drop list fields, specifies the distance in pixels the drop indicator will be drawn from the right edge of the control.

DropPosY*

For button drop list fields, specifies the distance in pixels the drop indicator will be drawn from the bottom edge of the control.

ExpandButtons*

For tree view fields, setting this property to true causes expansion buttons to be shown for nodes that have children.

Font*

Specifies the font to use for the field.

FontColor*

Specifies the color of the text for the field.

FontBold*

If set to true, the field text will be displayed in bold type.

FontItalic*

If set to true, the field text will be displayed in italic type.

FontUnderline*

If set to true, the field text will be underlined.

FullRowSelect*

When set to true, the entire row in the list view field is selected. When set to false, individual row items can be selected. Applies only when the list view is displayed in report view mode.

GridLines*

When set to true, grid lines are drawn between items in the list view. Applies only when the list view is displayed in report view mode.

ImageSize*

Specifies how list view images are sized. System indicates the images will be scaled to standard system sizes (16 by 16 or 32 by 32 pixels). First Image indicates images will be scaled to the size of the first image defined for the list view field.

Indent*

For tree view fields, specifies how many pixels child nodes are indented from the parent. The value 0 allows the control to automatically specify the amount.

IndicateColor*

Specifies the color of the progress indicator blocks or bar.

Lines*

Specifies how lines are drawn in the tree view field. If set to None, no lines are drawn. If set to TreeLines, lines are drawn for nodes below the root level. If set to RootLines, lines are drawn for all nodes.

Pattern*

Specifies the pattern to apply to the background.

PatternColor*

Specifies the color of the pattern that is applied to the background.

PatternSelect*

Specifies the pattern used when a push button-style check box is selected.

Position-Left*

Indicates the position of the left edge of the field, measured in pixels from the left edge of the window.

Position-Top*

Indicates the position of the top edge of the field, measured in pixels from the top of the window.

Resize-Horizontal*

Specifies the horizontal resize behavior when per field resizing is used. Refer to Resizing windows for more information.

Resize-Vertical*

Specifies the vertical resize behavior when per field resizing is used. Refer to Resizing windows for more information.

Scaling*

For picture fields, specifies how the picture pasted into the field will be scaled. Proportional indicates the picture will maintain its original size and proportions. Stretch indicates the picture will be stretched to fill the picture field.

ShowHeadings*

When set to true, column headings are shown in the list view. Applies only when the list view is displayed in report view mode.

ShowPartialItems*

For native list boxes, setting this property to true causes the list box to be drawn exactly the height indicated in the layout window. If there isn’t enough room to display the last item, it will be only partially drawn. When this property is set to false, the list box will be resized vertically to include just the last complete item.

ShowSelection*

For tree view and list view fields, indicates whether the selected node or item is indicated when the field does not have focus.

Size-Height*

Indicates the field height, measured in pixels.

Size-Width*

Indicates the field width, measured in pixels.

Style*

For push button and button drop list fields, specifies whether the button will display text only, graphics only, or both text and graphics. It also specifies the arrangement of the text and graphics.

For check box fields, specifies whether the field displays as a standard check box or a push button.

For progress indicator fields, specifies whether the progress indicator is composed of blocks or is a solid rectangle.

Visible*

If set to true, the field will be visible. If set to false, the field will be hidden.

Fields can’t be made invisible if they have the Required property set to true.

Zoom*

For push button fields, setting this property to true causes the pointer to become the zoom pointer (magnifying glass) when it’s moved over the field. Typically, the Visible property is also set to false to make the push button invisible.


Drawn object properties

The following table lists the drawn object properties. Asterisks indicate the properties that can be changed using the Modifier

Property | Description
Alignment* | For static text, indicates whether the text is left, center, or right-aligned.
Appearance* | Specifies whether the drawn object is displayed with a 2-D or 3-D border.
BackColor* | Specifies the background color of the object.
Border* | For static text, specifies whether a border is drawn around the object.
Font* | Specifies the type style and size to use for static text.
FontBold* | If set to true, static text will be displayed in bold type.
FontColor* | For static text, specifies the color of the text.
FontItalic* | If set to true, static text will be displayed in italic type.
FontUnderline* | If set to true, static text will be underlined.
LineColor* | Specifies the color of the line used to draw the object.
LineSize* | Specifies the width of the line used to draw an object.
Pattern* | Specifies the pattern to apply to the background.
PatternColor* | Specifies the color of the pattern that is applied to the background.
Position-Left* | Indicates the position of the left edge of the object, measured in pixels from the left edge of the window.
Position-Top* | Indicates the position of the top edge of the object, measured in pixels from the top of the window.
Resize-Horizontal* | Specifies the horizontal resize behavior when per field resizing is used. Refer to Resizing windows for more information.
Resize-Vertical* | Specifies the vertical resize behavior when per field resizing is used. Refer to Resizing windows for more information.
Shape* | Specifies the shape of an item drawn with the shape tool.
Size-Height* | Indicates the object height, measured in pixels.
Size-Width* | Indicates the object width, measured in pixels.
Zoom* | For static text items, setting this property to true causes the text to be displayed as specified by Zoom Fields settings in the User Display Preferences window.


Previewing a window

As you make modifications to a window, it’s useful to see how the window will appear when it’s displayed. To do this, choose Preview from the Layout menu. Remember that this is only a preview of the visual characteristics of the window; the window will not be functional. When you have finished, close the preview window to return to the Layout window.


Setting the tab sequence

A tab sequence is the order in which the focus moves through fields in a window when the TAB key is pressed. You may want to change a tab sequence to change the order in which users enter information, ensuring they enter information you consider most important first.

Setting a tab sequence is typically one of the last tasks you need to complete when modifying a window. After you’ve arranged the fields in the desired order, use the following procedure to set a tab sequence.

  1. Choose Set Tab Sequence from the Layout menu.

  2. Select the field you want first in the sequence by double-clicking the field.

The focus will appear in this field when the window is opened initially. The field you double-click will appear shaded, meaning that it’s now the first field in the tab sequence.

  3. Press the TAB key.

  4. Double-click the field you want next in the sequence.

The field will appear shaded, indicating it’s the next field in the tab sequence.

  5. Press the TAB key again and double-click the field you want third in the tab sequence.

Continue to mark fields in the window in the order you want, using the mouse to double-click the field and the TAB key to move the focus to the next object in the sequence.

  6. Test the tab sequence.

When the tab sequence for all the fields in the window has been set, press the TAB key several times to move through the tab sequence. When you’ve finished setting the tab sequence, choose Set Tab Sequence from the Layout menu.

You can use the TabStop property to exclude fields from the tab sequence.

You can stop the process of setting a tab sequence at any time by closing the Layout window and choosing not to save the changes to the window.

To make radio buttons work properly in your application, the radio group and radio button fields must be arranged properly in the window. In the tab sequence, the radio group must come immediately before the radio buttons. For example, in the Payment Method radio group shown in the following illustration, the Payment Method radio group field comes immediately before the Cash, Check and Charge radio button fields in the tab sequence.


Positioning the window

You can specify the opening position of each window. This allows you to arrange where a group of windows will appear on the screen, reducing the time users spend organizing windows on their screen.

You should be aware of the other objects, such as palettes or other windows, that will be on the screen at the same time as the window you’re positioning. Use the following procedure to position a window in your application.

  1. Choose Position Window from the Layout menu.

The Position Window window will appear in the location where the window will be positioned. The default position and size coordinates are displayed in the window.

  2. Drag the window to the location you want it to appear when opened.

Note that the coordinates change each time you move the window. Use the coordinates in the window to more accurately position this window. When the window is positioned in the proper location, click OK.


Adding fields to the window

You can use the Modifier to add fields from a window’s a uto-linked table, enabling you to display a more extensive range of information. Many Microsoft Dynamics GP windows are automatically linked to a particular table, making transfer of information between the window and table easier.

Some forms have several tables linked to them. However, each window can have only one auto-linked table. You can add fields from the window’s auto-linked table (displayed in the Properties window), but not from any other tables that may be linked to the form (displayed in the Form Tables window).

To add a field to the window, use the following steps.

  1. Drag the field to the window.

Select the appropriate field name from the window’s auto-linked table and drag it to the layout area.

  2. Set properties for the field.

Setting field properties is described earlier in a previous topic.

In most cases, it’s best to make the fields that you add to a window display-only. If you add editable fields to a window’s layout, be sure to test the modified window thoroughly. Use the lesson company to verify that information contained in the field is updated correctly, especially if the same field appears in more than one window within the same form.


Adding pictures

Graphics, such as a company logo, can be added to windows using standard cut-copy-and-paste techniques. If you want to use several custom graphics throughout your application, you can store these graphics in the picture library. This library allows you to add, name and store specific graphics in the forms dictionary. Adding pictures to the picture library is described in Pictures and Native Pictures.

If you paste a picture directly into the layout area, you’ll be prompted to name the picture. The picture will appear in the layout and be added to the picture library automatically.


Linking fields to prompts

You can link a field to the text prompt associated with it by using the Link Prompt item in the Tools menu. By linking a field to its prompt, the prompt can indicate the status of the field, such as if the field is disabled or required.

To link a field to a prompt, choose Link Prompt from the Tools menu. Click on the field and drag the mouse pointer to its prompt (the text describing the field). A flashing black line will indicate that the link was made. Linking a prompt is shown in the following illustration.

When you’ve finished, choose Link Prompt again to turn prompt linking off.


Resizing windows

Windows in Microsoft Dynamics GP can be resized by the user when they are displayed. The ability to resize a window is controlled by the Resizeable property for the window. If set to True, the window can be resized. Two types of resizing of resizing are supported: automatic and per field.

Automatic resizing

With automatic resizing, fields such as list boxes, text fields, tree views and list views will resize automatically when the window is resized. To use automatic resizing, set the Resizeable property for the window to True-Automatic. No additional work is required.

Automatic resizing was the type supported in earlier versions of Microsoft Dynamics GP.

When a window contains many fields, the rules necessary to properly resize the window and maintain the proper appearance become very complex. When a window layout becomes too complex for the runtime engine to automatically resize the window, it will no longer try to resize the controls in the window. When this occurs, you need to use per field resizing.

Per field resizing

To use per field resizing, set the Resizeable property for the window to True-Per Field. You must then specify the Resize Horizontal and Resize Vertical properties for each field in the window. These two properties specify the resize characteristics of the field.

You can specify resize characteristics for static text and drawn objects, as well.

The following tables describe the possible values for these properties:

Resize Horizontal

Value

Description

Grow

The field will keep its current horizontal position and grow horizontally by the same amount as the window.

Example: When the window is resized 100 pixels wider, the field will maintain its horizontal position and be 100 pixels wider.

Stay Centered

The field will keep its current horizontal size, but will slide horizontally at half the amount the window grows.

Example. When the window is resized 100 pixels wider, the field will maintain its horizontal size and slide 50 pixels to the right.

Stay Left

The field will keep its current horizontal size and horizontal position.

Example: When the window is resized 100 pixels wider, the field will maintain its horizontal size and position.

Stay Left - Grow

The field will keep its current horizontal position, and grow horizontally by half the amount the window grows.

Example: When the window is resized 100 pixels wider, the field will maintain its horizontal position and be 50 pixels wider.

Stay Right

The field will keep its current horizontal size, and move horizontally to maintain a constant distance from the right edge of the window.

Example: When the window is resized 100 pixels wider, the field will slide 100 pixels to the right.

Stay Right - Grow

The field will grow horizontally at half the amount the window grows, and move horizontally to maintain a constant distance from the right edge of the window.

Example: When the window is resized 100 pixels wider, the field will slide 100 pixels to the right and be 50 pixels wider.

Resize Vertical

Value

Description

Grow

The field will keep its current vertical position and grow vertically by the same amount as the window.

Example: When the window is resized 100 pixels taller, the field will maintain its vertical position and be 100 pixels taller.

Stay Bottom

The field will keep its current vertical size, and move vertically to maintain a constant distance from the bottom edge of the window.

Example: When the window is resized 100 pixels taller, the field will slide 100 pixels down.

Stay Bottom - Grow

The field will grow vertically at half the amount the window grows, and move vertically to maintain a constant distance from the bottom edge of the window.

Example: When the window is resized 100 pixels taller, the field will slide 100 pixels down and be 50 pixels taller.

Stay Centered

The field will keep its current vertical size, but will slide vertically at half the amount as the window grows.

Example. When the window is resized 100 pixels taller, the field will maintain its vertical size and slide 50 pixels down.

Stay Top

The field will keep its current vertical size and vertical position.

Example: When the window is resized 100 pixels taller, the field will maintain its vertical size and position.

Stay Top - Grow

The field will keep its current vertical position, and grow vertically at half the amount the window grows.

Example: When the window is resized 100 pixels taller, the field will maintain its vertical position and be 50 pixels taller.

The following illustration shows a window that is too complex to be resized automatically. The horizontal and vertical resize characteristics of each field are shown.


Auto-complete

You can use the AutoComplete property for string fields to automatically fill the contents of the field as the user types, based on the values previously entered for the field.

To use the auto-complete capability for a string field, you must set the AutoComplete property to true for every occurrence of the field for which you want the functionality. When a user adds a value to the field and moves the focus, the value is added to the auto-complete list for the field.

When the user begins to type characters into a field with the AutoComplete property set to true, the auto-complete list for the field will be examined to find any matches. The matching items will be displayed in a drop-down list. The user can continue typing a value to refine the items listed, or use the arrow keys or mouse to select one of the items in the list. If drop-down list isn’t large enough to fully display the auto-complete items, use the resize area in the corner of the list to expand the list.

To remove an item from the auto-complete list, right-click the item and choose Remove From List in the menu that appears.

If the same global field appears in multiple windows, and the AutoComplete property is set to true for each instance, the fields will share the auto-complete data. Auto-complete values entered in one field will also be available in the other field instances. The behavior is the same for a local field that appears in multiple windows within a form. If each instance of the local field has the AutoComplete property set to true, the local field will share the auto-complete data.

If the auto-complete field has a linked-lookup button, an additional item will appear at the bottom of the auto-complete list. Choosing this item will open the lookup window, just as if the lookup button had been clicked.

Values are added to the auto-complete list for a field any time the focus moves to the field, the content of the field changes, and the focus leaves the field. A user changing a field’s value, or a lookup window returning a value are common ways that values are added to the auto-complete list.

Auto-complete items are written to a file that is stored in the “Application Data” folder for the user currently logged into the workstation. By default, this folder is hidden in Windows Explorer. The auto-complete values stored in this table will be used the next time Microsoft Dynamics GP is run. To remove the auto-complete items for a user, you must delete the table that stores the items.


Linking fields to format fields

The formatting displayed for certain string and currency fields in Microsoft Dynamics GP is based on the value of an integer field called a format field. A format field is designated by choosing Link Format Selector from the Tools menu while the layout window is active. The Modifier will switch to format linking mode, allowing you to link the string or currency field to the format field. The Modifier will stay in this mode until you choose Link Format Selector from the Tools menu again.

While the Modifier is in format linking mode, you can link fields to format fields by dragging from a currency or string field to the integer field you want to link it to. A flashing border around the integer field will indicate that the link was successful. The value of the integer field indicates which format string should be used for the currency or string field. The integer field can be an invisible field or a field such as a drop-down list, allowing the user to specify the format.

Formatting currency fields

The possible formats for currency fields and the integer value associated with them are shown in the following table.

Integer | Format | Integer | Format
0 | Control panel defaults | 10 | $1,234.567
1 | 1,234 | 11 | $1,234.5678
2 | 1,234.5 | 12 | $1,234.56789
3 | 1,234.56 | 13 | 1,234%
4 | 1,234.567 | 14 | 1,234.5%
5 | 1,234.5678 | 15 | 1,234.56%
6 | 1,234.56789 | 16 | 1,234.567%
7 | $1,234. | 17 | 1,234.5678%
8 | $1,234.5 | 18 | 1,234.56789%
9 | $1,234.56 |  |

The integer value used to indicate the format used can be stored in a table along with the currency field being formatted. When the record is retrieved from the table, the currency field will display as it did when the record was saved. The format field can also be used for a report, allowing the currency field to appear in the report as it did when it was saved in the table.

Microsoft Dynamics GP can define its own formats, in addition to those shown in the previous table. This capability is used to define currency format information for multicurrency support.

Formatting string fields

For string fields, the integer value indicating the format to use corresponds to the position of the format string in the Format Definition window.

The following example describes a Part Number field that has three different format strings. The user selects the format to apply by selecting the corresponding format in a drop-down list linked to the Part Number field. The three format strings for the Part Number field, entered in the Format Definition window, are shown in the following illustration.

The drop-down list is set to the following value (integer 3), corresponding to the third format string:

The Part Number field will display the following format:

Using format fields

Unless you are creating your own fields, the presence of a format field typically won’t affect modifications you make to a window. You need to watch for fields that have their LinkedFormat property set. If you make modifications to these fields, be sure the LinkedFormat property remains unchanged.

Another situation to be aware of occurs when Microsoft Dynamics GP uses a format field to apply multicurrency formatting to currency fields in transaction entry windows. All of the currency fields in the window will be linked to a hidden format field typically named Currency Index. The value of this hidden field indicates what multicurrency formatting will be applied to all of the currency fields linked to it. If you add currency fields to the window, be sure to link those fields to the same format selector field that Microsoft Dynamics GP uses.


Modifying Scrolling Windows

Microsoft Dynamics GP has special windows called scrolling windows that allow the user to scroll through or enter information into tables. Scrolling windows are contained in standard windows. This portion of the documentation provides information about how to modify scrolling windows. It is divided into the following sections:

  • Opening a scrolling window layout
  • The layout area
  • Scrolling window properties
  • Adding fields to a scrolling window


Opening a scrolling window layout

Scrolling windows appear inside of standard windows. A scrolling window is shown in the following illustration.

The prompts for the scrolling window appear above it in the window layout. To modify these prompts, simply edit them in the window layout. If you want to modify the appearance of the scrolling window, you must open a second layout window. To do this, select the scrolling window and choose Open Scrolling Window from the Tools menu. A second layout window will appear, allowing you to edit the contents of the scrolling window.

You can also open a scrolling window by double-clicking it in the window layout that contains it.


The layout area

When you open a scrolling window, a second layout area is displayed. This layout window is similar to the standard layout window, but is used only to edit scrolling windows.

Scrolling windows are composed of lines. In the scrolling window layout, only one line of the scrolling window is shown. When the scrolling window is displayed, this line is drawn repeatedly, until the scrolling window is full.

Scrolling windows can display information in two modes: normal and expanded. The scrolling window layout specifies what items are displayed in each mode. The area in the scrolling window layout that corresponds to one line in normal mode is the area between the top of the window and the first dashed line. This area is called the small line item. The area in the scrolling window layout that corresponds to the extra items displayed in expanded mode is the area between the second dashed line and the small line item. This area is called the big line item.

To mark the small line item, choose Mark Small Line Item from the Tools menu and click where you want the dashed line to appear. You may need to move fields out of way to see where the small line item is placed. To mark the big line item, choose Mark Big Line Item from the Tools menu. Click where you want the line to appear. Note that the big line item must be marked in multiples of the height of the small line item.

The following illustration shows the layout for the IV_Transfer_Scroll scrolling window. In normal mode, the window will display the Item Number, Unit of Measure, Quantity and Unit Cost. In expanded mode, it will also display the Description, From Site and To Site.


Scrolling window properties

Before viewing properties, be sure the Properties window is open. To view the scrolling window’s object properties, the scrolling window layout must be open. Once the layout is open, select the arrow tool from the Toolbox and click in the Layout window outside of the scrolling window’s area to select it. The scrolling window is selected when resize handles appear on its perimeter. The following table lists the scrolling window object properties.

Object property

Description

DefaultDblClick

In a browse-only scrolling window, setting this property to true allows the user to double-click a line in the scrolling window to accomplish the action of selecting a line and clicking the push button whose Default property is set to true.

HelpContextID

Lists the help context ID value for the scrolling window.

LinkTable

This is the table linked to the scrolling window. Records displayed in the scrolling window come from this table.

LinkTableKey

This is the key for the linked table that specifies the default sorting order for records in the scrolling window.

Name

This is the name of the scrolling window.

ScrollToBottom

Setting this option to true causes the scrolling window to display records at the end of the linked table, rather than at the beginning. In effect, the scrolling window has been scrolled to the bottom of the table.

WindowID

Lists the resource ID of the scrolling window.

WindowType

Specifies whether the scrolling window is browse-only, editable or adds-allowed.

An adds-allowed scrolling window has a blank line at the bottom of the window where the user can add new records and save them in the linked table.

A browse-only scrolling window allows the user to select only one line in the scrolling window and make no changes.

An editable scrolling window allows the user to edit and change the contents of lines in the scrolling window. These changes can be saved in the linked table.

To view the scrolling window’s visual properties, only the window that contains the scrolling window must be open. Select the arrow tool from the Toolbox and click in the scrolling window to select it. The following table lists the scrolling window visual properties.

Visual property | Description
AltLineColor* | If this property is set to true, alternate lines of the scrolling window will appear with a different color.
Appearance* | Specifies whether the scrolling window has a 2-D or 3-D border.
BackColor* | Specifies the background color of the scrolling window.
FontColor* | Specifies the color of the text in alternate lines of the scrolling window.
Pattern* | Specifies the pattern to apply to the background.
PatternColor* | Specifies the color of the pattern that is applied to the background.
Position-Left* | Indicates the position of the left edge of the scrolling window, measured in pixels from the left edge of the window.
Position-Top* | Indicates the position of the top edge of the scrolling window, measured in pixels from the top of the window.
Resize-Horizontal* | Specifies the horizontal resize behavior for the scrolling window when per field resizing is used. For more information, refer to Resizing windows for more information.
Resize-Vertical* | Specifies the vertical resize behavior for the scrolling window when per field resizing is used. For more information, refer to Resizing windows for more information.
Size-Height* | Indicates the scrolling window height, measured in pixels.
Size-Width* | Indicates the scrolling window width, measured in pixels.


Adding fields to a scrolling window

You can add fields to the scrolling window from the linked table. Adding fields to a scrolling window is similar to adding fields to a standard window. Simply select the field in the Toolbox and drag it to the layout area. Be sure you place the field in either the small line item or the big line item. Otherwise, it won’t be displayed in the scrolling window.


Modifying Menus

Microsoft Dynamics GP provides a set of command-based menus that allow navigation for the application. These menus cannot be accessed with the Modifier. You can use the Modifier to make changes to the menus that are part of individual forms. Form-based menus appear as additional menus for individual windows in Microsoft Dynamics GP. This topic is divided into the following sections:

  • Opening a menu definition
  • Editing menu items


Opening a menu definition

To open a menu definition, first open the Form Definition window for the form the menu is part of. Click the Menus tab to display a list of menus for the form. Select a menu and click Open.

The Menu Definition window will appear, as shown in the following illustration.


Editing menu items

You can edit the display name and the names of the items in each menu attached to the form.

Display name

The display name is the name that appears when the menu is displayed as a submenu.

You can define an access key for the menu by placing an ampersand (&) in the menu display name. The ampersand won’t be displayed in the menu name. Instead, the character immediately following the ampersand will be underlined. To choose the menu, a user can press the alt key and the underlined character at the same time.

Menu items

The items in the menu are listed in the Menu Items list. To change the name of a menu item, select it in the list and then edit it in the Item Name field. The &, #, -, and ~ characters have special meaning in menu item names. These characters are described in the following table.

Character | Effect
& | Causes the next character to appear underlined and act as the access key.
# | Draws an ellipsis (…) after the item.
- | If used as the item name, causes a separator line to appear in the menu. Use separator lines to group items in the menu.
~ | Draws a forward slash (/).

You can define a shortcut for the menu item by selecting a value from the Shortcut field. The shortcut is CTRL + the specified character. To avoid conflicts, be sure the shortcut key isn’t used more than once.


Adding New Fields

You can also use the Modifier to create and add new fields to windows. This capability is designed primarily for users who also use Visual Basic for Applications (VBA), Visual Studio Tools for Microsoft Dynamics GP, or the Continuum API to further customize Microsoft Dynamics GP. Any of these code development mechanisms can use new fields created with the Modifier.

Information about adding new fields is divided into the following sections:

  • Creating local fields
  • Using the Toolbox
  • Adding prompts
  • Control types
  • Working with controls


Creating local fields

Local fields are specific to a single form, and all windows from the form will have access to the local fields. To add a local field to a window, perform the following steps.

  1. Open the window layout.

Open the window layout for the window on which you want to add a new field.

  2. Create a new local field.

In the Toolbox, choose Local Fields in the drop-down list specifying the type of fields to display.

Click New; the Local Field Definition window will appear.

  3. Name the field and set the field characteristics.

Name the field and specify its characteristics. You can specify the following characteristics:

Array Size An array field contains multiple occurrences of the same type of information. The individual pieces of information stored by the array field are referred to as elements. The array size of a field indicates the number of elements that will be included in the array field. If the field won’t be an array, set the array size to 0.

Control Type The control type determines the function of the data type and how it will display data. The control type is the main characteristic of a data type. A list of control types can be found in Control types.

Keyable Length The keyable length is the number of characters a user can enter in a field. Control types such as currency, integer and string have a keyable length.

Static Values Static values are any text and pictures that can be associated with a data type. Static values are described in detail in Static values.

  4. Drag the field to the layout area.

Select the appropriate local field name from the Toolbox and drag it into the layout area. The side of the new field is the default size based on the field’s control type and current display properties.

  5. Set properties for the field.

Use the Properties window to set properties for the new field. The properties for fields are described in Field properties.


Using the Toolbox

You can also use the tools in the Toolbox to add new local fields to a window. To do this, select one of the tools and then click in the layout window. A new local field with the specified control type will be created for the current form and placed on the window. The name of the new control will be based on the tool used to create it.

To further specify characteristics of the new local field, set the drop-down list in the Toolbox to display local fields. Locate the new field in the list and then click Open. The Local Field Definition window for the new field will be displayed, allowing you to edit its characteristics.


Adding prompts

Once you’ve created a new field and added it to a window, you may want to create a prompt for the field. For the best appearance, the prompt should have characteristics similar to other prompts in Microsoft Dynamics GP. Use the following procedure to create a prompt.

  1. Create the prompt.

Select the Text tool in the Toolbox, then click in the layout area. Type the text for the prompt.

  2. Set the prompt properties.

Select the prompt with the Arrow tool. Set the following properties in the Properties window’s Visual tab:

Appearance | 3D Highlight
BackColor | System - Button Face
Border | True
Font | System
FontColor | System - Button Text
Pattern | (none)
PatternColor | Black

These settings allows the prompt color to automatically be updated based on the color scheme the user selects in the User Display Preferences window.

  3. Resize the prompt box.

With the Border property set to true, a border will appear for the prompt. Select the prompt using the arrow tool. Using the handles, adjust the prompt until it’s the desired size.

  4. Link the field to the prompt (optional).

You may want to link the field to the new prompt. This is especially useful if you set the field’s Required property to true. Then the prompt will visually indicate the field is required. Linking prompts is described in Linking fields to prompts.


Control types

A new local field is assigned one of several predefined control types. This section describes the recommended control types you can use for new fields. We don’t recommend creating new fields with control types not in this list. An example or illustration, keyable length, types of static values used, and a description of the control type’s function are provided for each control type. The following control types are described:

  • Boolean
  • Button drop list
  • Check Box
  • Combo Box
  • Currency
  • Date
  • Drop-down list
  • Integer
  • List box
  • Long integer
  • Multi-select list box
  • Non-native list box
  • Progress indicator
  • Push button
  • Radio button
  • Radio group
  • String
  • Text
  • Time
  • Visual switch


Boolean

Keyable length

Not applicable

Static values

None

Function

Stores a boolean (true or false) value. The default value is false.


Button drop list

Keyable length

Not applicable

Static values

Pictures, text, or both pictures and text for the button. Text for items in the list.

Function

Allows one item to be selected in the list. The value in the field is an integer that corresponds to the position of the last item selected in the list. The items in the list are numbered starting with 1. This control is used as a means of navigation.


Check Box

Keyable length

Not applicable

Static values

Text, pictures or native pictures for the prompt

Function

Stores and displays a boolean (true or false) value. The value in the field is true if marked and false if unmarked.


Combo Box

Keyable length

Up to 255

Static values

Text for items in the list

Function

Allows a text item to be entered by a user or chosen from the list. The value in the field is a string.


Currency

Keyable length

Up to 19

Static values

None

Function

Displays a value as a currency amount, with a currency symbol and thousands separator if specified in the data type’s format.

The currency value can be in the range [-99,999,999,999,999.99999 to 99,999,999,999,999.99999]. The decimal point is implied in the number, but not actually stored. For display purposes, currency values are limited to 14 digits to the left of the decimal and 5 digits to the right.


Date

Keyable length

Up to 10

Static values

None

Function

Stores and displays a date. The date is entered in MMDDYYYY form and is displayed according to the system settings, in short form. The year values can range from 1800 to 9999.

The runtime engine automatically checks each date value to ascertain whether its values are within the acceptable ranges of a date value. If the date is not valid, a message is displayed.

An uninitialized date field (one that hasn’t been set to a value) will have the value 00000000. This is an acceptable date value.


Drop-down list

Keyable length

Not applicable

Static values

Text for items in the list

Function

The value of the field is an integer corresponding to the position of the selected item as it appears in the Static Text Values window. The items in this list are numbered sequentially so that the first item in the list is 1, the second is 2, and so on. If the static text items are sorted for display, the value of the field still is based upon the selected item’s position in the Static Text Values window, not its position as displayed in the list at runtime. Up to 32,767 items can be displayed in the list.


Integer

Keyable length

Up to 5

Static values

None

Function

Displays and stores integers from -32,768 to 32,767.


List box

Keyable length

Not applicable

Static values

Text for items in the list

Function

Allows only one item to be selected in the list box.

The value of the field is an integer corresponding to the position of the selected item as it appears in the Static Text Values window. Items are numbered sequentially so that the first item in the list is 1, the second is 2, and so on. If the static text items are sorted for display, the value of the field still is based upon the selected item’s position in the Static Text Values window, not its position as displayed in the list box at runtime. Up to 32,767 items can be displayed in the list.

The list box control is created using the current operating environment’s native list box control. It is preferable to use the list box control, rather than the non-native list box control.


Long integer

Keyable length

Up to 10

Static values

None

Function

Displays and stores integers from -2,147,483,648 to 2,147,483,647.


Multi-select list box

Keyable length

Not applicable

Static values

Text for items in the list

Function

Allows multiple items to be selected in the list box. Up to 32 items can be displayed in the list. The CTRL key is used to select non-consecutive items.


Non-native list box

Keyable length

Not applicable

Static values

Text for items in the list

Function

Allows only one item to be selected in the list box.

The value of the field is an integer corresponding to the position of the selected item as it appears in the Static Text Values window. Items are numbered sequentially so that the first item in the list is 1, the second is 2, and so on. If the static text items are sorted for display, the value of the field still is based upon the selected item’s position in the Static Text Values window, not its position as displayed in the list at runtime. Up to 32,767 items can be displayed in the list.

A non-native list box control is created completely by the runtime engine.


Progress indicator

Keyable length

Not applicable

Static values

None

Function

Allows progress to be shown visually. The indicator position is based on the value of the progress indicator field. The valid values range from 0 to 100. When set to 0 or less, no indicator is displayed. When set to 100 or greater, the entire indicator is displayed. For values in between, the amount displayed is proportional to the value.

Several properties control the display characteristics of the progress indicator, such as style and indicator color. If the indicator is composed of blocks, the block size is set automatically based upon the height of the progress indicator.


Push button

Keyable length

Not applicable

Static values

Text, pictures or native pictures

Function

Provides a means of starting processing. The action associated with the field is run when the button is clicked.


Radio button

Keyable length

Not applicable

Static values

Text for each radio button prompt

Function

Radio button values are stored using a radio group. The value of the radio group is an integer that corresponds to the radio button currently selected. A specific radio button’s value is determined by its position in the tab sequence; the first radio button’s value is 0, the second is 1, and so on. The radio group must come immediately before the radio buttons in the tab sequence.


Radio group

Keyable length

Not applicable

Static values

None

Function

Groups and stores a single value for the radio buttons inside the radio group.

The value stored is an integer corresponding to the position of the selected radio button in the tab sequence; if the first radio button is selected, the value 0 is stored; if the second one is selected, the value 1 is stored, and so on. The radio group must immediately precede the radio buttons in the tab sequence.


String

Keyable length

Up to 255

Static values

None

Function

Allows entry and display of strings of up to 255 characters.


Text

Keyable length

Up to 32,000

Static values

None

Function

Displays text and allows a user to enter text into the application. The text will wrap only if the WordWrap property for the field using the data type is set to true. Scroll bars can be turned off by setting the ScrollBars property for the field using the data type to false.

Up to 32,000 characters can be stored in the field.


Time

Keyable length

Up to 6

Static values

None

Function

Time is entered in 24-hour format, such as 181732, and is displayed in 12-hour format, such as 6:17:32 PM. The runtime engine automatically checks each time value to ascertain whether it’s within the proper range of a time value.

An uninitialized time field (one that hasn’t been set to a value) will have the value 000000. This is an acceptable time value.


Visual switch

Keyable length

Not applicable

Static values

Text, picture or native picture

Function

Displays a series of items. The next item in the field is displayed when the field is clicked. The value of the field is an integer corresponding to the position of the currently-displayed item in the series, starting with 1 and incremented by 1.


Working with controls

This section contains specific information about how to work with the most common controls you can create in the Modifier, such as push buttons, button drop lists and check boxes.

Push buttons

Push buttons provide a method of starting processing in an application. A push button can display a text item, a graphic item, or both text and graphics. Either pictures or native pictures can be used.

Use the Style property for the push button field to specify which types of items are displayed on the button. The Style property also controls the arrangement of the items. The following table shows the arrangements possible for text and graphics on a push button.

Style | Example
Text Only |
Graphic Only |
Text on Top |
Text on Bottom |
Text on Right |
Text on Left |

A push button can have up to three images: an Up image, a Down image and an Over image. The Up image is displayed when the button isn’t being clicked. The Down image is displayed when the button is being clicked. The Over image is displayed when the pointer is positioned over the button.

If you supply only the Up image for a push button, the Down image will be drawn automatically when the push button is clicked.

Check boxes

You can use picture static values with check boxes. In addition, you can use the Style property to specify whether the check box will appear as a standard check box or as a push button. The following illustrations show how check boxes look with the various styles.

 | Normal style | Push button style
Marked |  |
Not marked |  |

If you change the Style property for a check box that uses static picture values, use the Size to Default tool in the toolbox to resize the check box field to the appropriate size.

If you use pictures (picture resources) as the static values for a push button-style check box, you can specify two, four or six images. These images are used for the various check box states.

  • If you specify two images, these images will be used for the up and down states, respectively.
  • If you specify four images, these will be used for the up, up clicked, down, and down clicked states, respectively.
  • If you specify six images, the Appearance property for the check box must be set to 3D Highlight. The images will be used for the up, up clicked, down, down clicked, up highlight and down highlight states, respectively.

Button drop lists

Button drop lists are typically used to provide a method of navigation in an application. When you define a button drop list data type, you can specify what will appear on the button and the static text items that will appear in the list.

The button portion of a button drop list can display a text item, a graphic item, or both text and graphics. You must use pictures for graphics that appear on the button drop list. In versions of Microsoft Dynamics GP prior to 6.0, native pictures were used.

A button drop list can have up to three images: an Up image, a Down image and an Over image. The Up image is displayed when the button isn’t being clicked. The Down image is displayed when the button is being clicked. The Over image is displayed when the pointer is positioned over the button drop list.

Use the Style property for the button drop list field to specify which types of items are displayed on the button. The Style property also controls the arrangement of the items.

If you select 3D Highlight for the Appearance property, the text caption in the button portion of the button drop list will become bold when the field has the focus. Be sure to provide extra space for the caption to accommodate the bold text.

Typically, button drop lists have a drop indicator (a small triangle) in the lower-right corner of the field. It’s not necessary to include the drop indicator in the image for the button drop list. Instead, set the DropIndicator property to True. Use the DropPosX and DropPosY properties to specify the distance the drop indicator will appear from the lower-right corner of the button drop list.


Global Modifications

The Modifier also allows you to make changes that will affect the entire application interface. This part provides detailed information about the various global resources you can modify in Microsoft Dynamics GP. The following items are discussed:

  • Data Types describes data types and how they control characteristics of fields.
  • Formats describes how formats are used to control how data is displayed.
  • Global Fields explains how to examine global fields in the accounting system.
  • Pictures and Native Pictures describes how to use the Modifier to create and modify picture resources.
  • Strings explains how to modify string resources in Microsoft Dynamics GP.
  • Messages explains how to modify message resources in Microsoft Dynamics GP.


Data Types

Data type resources specify the characteristics of all fields used in an application. If you want to change the characteristics of a field, you need to change its corresponding data type. Keep in mind that a single data type can be used by multiple fields. When you change the data type, you change the characteristics of all the fields that use it. Information is divided into the following sections:

  • Opening a data type
  • Keyable length
  • Static values
  • Format


Opening a data type

To open a list of data types, click the Data Types button on the toolbar or choose Data Types from the Resources menu. In the Data Types window, select a data type and click Open. The Data Type Definition window will appear, as shown in the following illustration.

The data type’s name appears at the top of the window. The Control Type field specifies the function of the data type, indicating how it will display and store data. The other fields in the window specify the additional characteristics of the data type. The following sections describe the data type characteristics you can change with the Modifier.


Keyable length

The keyable length is the number of characters a user can enter in a field that uses this data type. Control types such as currency, integer and string have a keyable length. You can use the Modifier to change the keyable length. For example, you may want to increase the keyable length for the STR10_Phone data type to allow the user to enter more digits. The following table lists control types for which you can set the keyable length.

Control type | Maximum keyable length
Combo box | Storage Size - 1
Currency | 19
Integer | 5
Long integer | 10
String | Storage Size - 1
Text | 32,000


Static values

Certain control types allow you to specify static values for the data type. Static values are any text or pictures associated with a data type that are displayed by a field using that data type. For example, the text on a push button and the items in a list box are static values. To view the static values for a data type, click the Static Values lookup button.

Static text values

The following table lists the control types that use static text values.

Control type | Static text used to:
Button Drop List | Indicate the text on the button and the selections in the list.
Check box | Indicate the check box prompt name.
Drop-down list | Indicate the selections in the drop-down list.
List box | Indicate the selections in the list box.
Push button | Indicate the text displayed on the button.
Radio button | Indicate the name displayed next to the button.
Visual switch | Display two or more text values that will be displayed in sequence as the user clicks the visual switch.

The Button Items window is used to specify the static text for button drop lists and push buttons.

To edit a static text value, select the appropriate Up, Down or Over caption. Enter the new text and then click OK in the Button Items window to save the changes.

Push buttons can be clicked using access keys (pressing ALT in combination with a letter). When the push button is displayed, an underscore beneath one of the letters in the static text for the push button indicates the button has an access key. To define an access key, place an ampersand (&) in the static text value for the button before the letter that will act as the access key.

The Static Text Values window is used to specify the static text for check boxes, drop-down lists, list boxes, radio buttons and visual switches.

To edit a static text value, select it in the Static Text Values list. Make the appropriate changes in the New Value field, then click Replace. You can mark or unmark the Sort List option, depending on whether you want the static items sorted.

Static picture values

Some control types use graphics as static values. Two kinds of resources are used as static picture values:

  • Native picture resources are specific, or native, to a particular operating system.
  • Picture resources are pictures you’ve added to the picture library. They are stored in a generic format that can be used on any supported operating system.

The following table lists the control types that can use static picture values:

Control type | Static picture usage
Push button | Pictures and native pictures can be used for images on the button.
Check box | Pictures and native pictures for the control.
Button drop list | Pictures and native pictures can be used to indicate the images for the button part of a button drop list.
List view | Pictures can be used for items appearing in the list.
Tree view | Pictures can be used with nodes appearing in the tree.
Visual switch | Can display two or more pictures or native pictures to set up a sequence of images that will change as the user clicks the visual switch.


Format

A format contains extra characters, spacing and attributes that can be applied to a data type when data is entered or displayed. Formats are described in the next topic.


Formats

Formats are the extra characters, spacing and attributes that can be applied to a data type to format data when it is entered or displayed. For example, a string data type for a phone number can have a format applied to it so a field using the data type will display a phone number as (555) 123-4567 instead of 5551234567.

Formats are stored as separate resources, but are applied to data types to help define how information is displayed. A single format resource can be used by several data types. Perhaps the easiest way to understand what formats are is to view them as data “masks” that simply change the look of the information in a field without changing the actual information itself. Information about formats is divided into the following sections:

  • Opening a format
  • Formatting options
  • Format string


Opening a format

To open a list of formats, choose Formats from the Resources menu. The Formats window will appear. To create a new format, click New. To open an existing format, select one in the list and click Open. The Format Definition window will appear, as shown in the following illustration.

Each format has a name. Typically, the name indicates the data type the format is applied to. For instance, the name STR_Employer_ID_Number indicates a format that will be applied to a data type used for an employee ID number.


Formatting options

You can use several formatting options to change how specific types of data will appear. You can use them to specify the following characteristics:

  • Align information to the left, right or center of a field.
  • Determine what characters will appear in unused parts of a field.
  • Specify how you want currency fields to appear.
  • Specify how numeric fields display information.

The following tables describe the various formatting options:

Numeric formats
Decimal Digits | Number of decimal places (0 to 5).
Negative Symbol | The operating system setting, a minus sign, the letters CR, or parentheses.
Alignment | Number is left-, center- or right-aligned.
Fill | Unused spaces are filled with asterisks, zeros or spaces.
Unsigned | If marked, the negative symbol won’t be displayed.
Show Thousands Separator | If marked, the field will show thousands separators in the number.
Show Percent Sign | If marked, the field will show the percent sign.

Currency formats
Decimal Digits | Number of decimal places (0 to 5).
Negative Symbol | The operating system setting, a minus sign, the letters CR, or parentheses.
Alignment | Number is left-, center- or right-aligned.
Fill | Unused spaces are filled with asterisks, zeros or spaces.
Unsigned | If marked, the negative symbol won’t be displayed.
Show Thousands Separator | If marked, the field will show thousands separators in the number.
Relative Decimal Position | If marked, the number of decimal digits selected is added to the number in the operating system setting. The total can be up to 5 decimal digits.
Show Currency Symbol | If marked, the currency symbol specified in the operating system settings is displayed.

String and composite formats
Alignment | String is left-, center- or right-aligned.
Fill | Unused characters are filled with asterisks, zeros or spaces.
Trailing Blanks | If marked, any spaces that follow the contents of the field will be saved in the table. If the option isn’t marked, any spaces following the item in the field won’t be saved. Leave unmarked to ensure that the same entry made with or without trailing blanks will be stored with the same value.
Leading Blanks | If marked, spaces can be entered as the first characters in the field. These spaces will be saved in a table.
Numeric Only | If marked, only numbers can be entered in the field.
Alphanumeric Only | If marked, only letters and numbers can be entered in the field.
Uppercase Only | If marked, all alphabetic characters will be displayed in uppercase.


Format string

The Format Definition window allows you to specify a format string for string and composite data types.

String formats

Format strings are used with string data types to add static elements to a field, such as parentheses or static text. The Modifier uses the capital X as a place holder to represent alphanumeric characters that will appear in the field. All other characters will be displayed as you type them.

Example 1

For instance, suppose you’re using a specific data type to store information entered in phone number fields. This Phone_Number data type uses a format and a format string to determine how phone numbers will appear at runtime:

Format string | Data entered | Data displayed
(XXX) XXX-XXXX | 7015550100 | (701) 555-0100
ext. XXXX | 6590 | ext. 6590

The Xs are placeholders indicating where the digits will be displayed, while the parentheses and dash are displayed just as you typed them. When the field is displayed and the phone number is entered, the format string will automatically display the special characters in the field.

Also note that a lowercase x is used in the “ext.” abbreviation in the second format string. Only uppercase Xs are treated as place holders, so the lowercase x is displayed in the field, instead of being replaced when data is entered.

Static characters in a format string aren’t actually stored with the data in the table. This allows you to change the format string without affecting how data is stored.

Composite formats

A format string is used with a composite data type to indicate the size and order of the components of the composite, and to add static elements, such as parentheses or static text. The numeric characters 1 through 9 are used to represent the characters of each component of the composite. All other characters will be displayed just as you type them.

Not all composites use a format string. Some composite fields, such as the Microsoft Dynamics GP Account Number, have their format defined through program code.

Example 2

The following example shows the use of a format for a standard composite. A composite must have a format and a format string. This composite contains three parts, as indicated by the format string.

Format string | Data entered | Data displayed
1111-22-3333 | 1000ND5050 | 1000-ND-5050

Note that the 1s, 2s and 3s are used as placeholders.


Global Fields

Fields represent the individual pieces of information in an application. They can appear in windows and be stored in tables. Each field uses a data type to specify its characteristics. Two types of fields are used in applications: global fields and local fields.

  • Global fields can be used in window and can also be stored in tables.
  • Local fields can be used only in windows. They are described in Adding New Fields.

Information about global fields is divided into the following sections:

  • Opening a global field
  • Opening a field’s data type


Opening a global field

To open a list of global fields, click the Fields button on the toolbar or choose Fields from the Resources menu. In the Fields window, select a global field and click Open. The Field Definition window will appear, as shown in the following illustration.

You can also open the Global Field Definition window from the Layout window. Select Global Fields as the type of field to display in the Toolbox. Select a field name in the list and click Open.


Opening a field’s data type

When the Field Definition window is open, you can easily drill down to the data type definition used for that field. To open the Data Type Definition window, click Open.


Pictures and Native Pictures

Two types of pictures are used in Dexterity-based applications: pictures and native pictures. Pictures are stored in a generic format and can be displayed on any platform. They are typically used to display large graphics and logos in an application. Native pictures are pictures that are used only on a particular platform. They are used to display pictures on push buttons and visual switches.

Information about pictures and native pictures is divided into the following sections:

  • Pictures
  • Adding a picture to the picture library
  • Using a picture from the picture library
  • Creating native pictures
  • Synchronizing native pictures
  • Using native pictures


Pictures

Pictures are stored in a generic format and can be displayed on any platform. Currently, the Modifier can convert Windows metafiles to a form that can be stored in the picture library. Pictures up to 32K in size can be stored. Pictures are stored only once, but can be placed in several windows of an application using the picture tool from the Toolbox in the Layout windows.

A company or product logo can be pasted into the picture library and used in Microsoft Dynamics GP windows. The following picture is the logo that is used for business alerts.


Adding a picture to the picture library

Choose Pictures from the Resources menu; the Pictures window will appear.

  1. Create a new picture or edit an existing one.

Click new to create a new picture or select a picture and click Open to edit it. The Picture Definition window will appear, as shown in the following illustration.

  2. Name the picture.

In the Picture Definition window, name the picture.

  3. Add the picture.

Be sure the picture you want to add is in the Clipboard. Click in the area below the Picture Name field to select it, and the choose Paste from the Edit menu to paste the picture into that area.

  4. Click OK to add the picture to the library.


Using a picture from the picture library

Open the layout of the window where you want to paste a picture.

  1. Select the picture tool.

  2. Click in the layout area where you want the picture to appear.

After you click in the layout area, the Pictures window will appear, allowing you to select a picture to paste into the layout.

  3. Select the picture to paste.

From the Pictures window, select the name of the picture to paste into the window and click OK.

  4. Position and resize the picture if necessary.

You can paste a picture directly into the window layout, bypassing the step of adding the picture to the picture library. Simply copy the picture to the Clipboard and choose Paste from the Edit menu to paste it into a window layout. You’ll be asked to name the picture. The picture will appear in the layout and will be added to the picture library automatically.


Creating native pictures

Choose Native Pictures from the Resources menu. The Native Pictures window will appear.

  1. Create a new native picture or edit an existing one.

Click New to create a new native picture or select a native picture and click Open to edit it. The Native Picture Definition window will appear, as shown in the following illustration.

  2. Name the native picture.

In the Native Picture Name field, enter the name of the native picture for this platform.

  3. Add the native picture.

Be sure the picture you want to add is in the Clipboard. Click Paste to paste the picture into the Native Picture Definition window.

  4. Click OK to save the native picture.


Synchronizing native pictures

If you will be using native pictures on more than one platform, you must create corresponding native pictures on both platforms. These pictures must be synchronized (given the same internal ID) so the correct picture will be displayed on each platform.

  1. Create the native picture on the first platform.

When you create the first native picture, be sure the Synchronize With option in the Native Picture Definition window is unmarked.

  2. Access the Modifier on the next platform.

  3. Create the corresponding native picture for the new platform.

Before you save the native picture, mark the Synchronize With option. A list of pictures from the first platform will be displayed.

  4. Select the name of the appropriate picture from the first platform and click OK.

The pictures will automatically be given the same internal ID.


Using native pictures

Follow these guidelines when using native pictures in the Modifier.

Push buttons

When you use them for push buttons, two native pictures are required. The “button up” picture is displayed when the button is not being clicked. The “button down” picture is displayed when the button is being clicked. Often, the button up and button down pictures are drawn to produce a three-dimensional effect (offsetting the button down picture one pixel down and to the right) when the button is pushed. To have the best appearance, the native pictures used should be the same physical size.

The following illustration shows the native pictures used for a lookup button. The button up and button down pictures were synchronized so the correct picture is displayed for each platform. Native pictures can be created so they appear as similar as possible, or different for each platform.

Visual switches

Visual switches can be used to display a series of native pictures. For each image displayed, only one native picture is required. To have the best appearance, all native pictures used for the visual switch should be the same physical size.


Strings

A string is a sequence of up to 79 characters that doesn’t contain carriage returns. Strings are used throughout the accounting system for window names, field prompts and static text values. Information about strings is divided into the following sections:

  • Using strings
  • Modifying a string


Using strings

The strings resource allows you to update all occurrences of a string in one step instead of changing the same string in each place it occurs.

For example, to change all occurrences of the words “Customer Name” to “Client Name,” you could select the Customer Name string and change it to Client Name instead of changing each individual prompt, text value or window name.

Note that changing a string with the Modifier will change it only in the interface. The string won’t be changed in any reports. To change strings in reports, you must use the Report Writer.


Modifying a string

Choose Strings from the Resources menu. The Strings window will open, allowing you to select the string to edit.

The Microsoft Dynamics GP dictionary contains several thousand strings. The Strings window may take a few moments to open.

  1. Select the appropriate dictionary core.

String resources are divided into several cores, which are special divisions in the dictionary. Microsoft Dynamics GP has a core for each major module category. When locating a string, begin by choosing the core that the string is most likely contained in. For example, the string “Customer” is likely part of the Sales core, so begin looking there. If you don’t find a string in a particular core, look in the other available cores.

  2. Select the string to edit.

After you have located the string, select it in the list and click Open. The String Definition window will appear, as shown in the following illustration.

  3. Edit the string.

Edit the string in the String Definition window and click OK to save the modified string.


Messages

Messages are a type of resource that associates a text string with an ID. In Microsoft Dynamics GP, messages are used to store the text that provides information or prompts a user to make a selection. Messages are also used to store other strings used in the accounting system, such as the names of reports. Information about messages is divided into the following sections:

  • Finding messages
  • Replacement markers
  • Modifying messages


Finding messages

To find messages in Microsoft Dynamics GP, you will need to generate a resource report. This report lists all of the resources in the current dictionary, including message resources. To generate a resource report, choose Generate Resource Reports from the File menu. Specify a file name and location and then save the report.

Microsoft Dynamics GP contains several thousand resources. Generating the resource report may take a few minutes.

After the resource report has been generated, you can use a text editor to search for specific messages. Once you have found the message, you can see its message ID.


Replacement markers

Some messages contain replacement markers. A replacement marker is a percent symbol (%) followed by a number. Replacement markers indicate positions in the message text where additional information will be substituted when the message is displayed. If you edit a message, be sure to leave the replacement markers in place. Otherwise, the message won’t be displayed properly.


Modifying messages

Choose Messages from the Resources menu. The Messages window will open, allowing you to edit messages.

  1. Enter the message ID.

Enter the ID of the message you want to edit. The message will be displayed.

  2. Edit the message text.

Make the changes to the message string and click Save.


Storing and Accessing Modifications

This portion of the documentation contains information about how modifications you make are stored and accessed. The following items are discussed:

  • Storing Modifications explains how modifications are stored and describes two common Modifier configurations.
  • Accessing Modifications describes how to control access to the Modifier and to forms that you have modified.
  • Packaging Modifications explains how you can package and distribute modifications to other users.


Storing Modifications

All modifications you make with the Modifier are stored in the Forms dictionary. Information about storing modifications is divided into the following sections:

  • Forms dictionary
  • Launch file
  • Modifier configurations


Forms dictionary

All changes and additions you make using the Modifier are stored in the forms dictionary for the application. By storing the new and modified resources in a separate dictionary, the integrity of the main dictionary can be maintained. For example, the following illustration shows the dictionary for Microsoft Dynamics GP and its associated forms dictionary.

When you access the Modifier for the first time, all of the core resources for the application dictionary are copied to the forms dictionary. Core resources include strings, data types and global fields that are used by several parts of the system. Once core resources have been copied to the Forms dictionary, the runtime engine will look there first when it retrieves resources from the dictionary. Any additions or modifications you make to core resources will be stored in the forms dictionary. The modifications will be accessed automatically when you use Microsoft Dynamics GP.

When you select a form to modify, that form is copied into the forms dictionary. Any modifications or additions you make to that form will be stored only in the forms dictionary. To access the modifications you make to forms, you must set security in the accounting system to access the modified form. This is described in Accessing Modifications.


Launch file

When you start Microsoft Dynamics GP, you use the launch file that tells the runtime engine which dictionaries will be used by the application. The launch file stores the location of the application dictionary as well as the names and locations of any forms or reports dictionaries.

By default, the forms dictionary is named Forms.dic and is located in the Data folder for the Microsoft Dynamics GP installation. You can use the Edit Launch File window to change the name or location of the forms dictionary.

To update the launch file, you must have appropriate user privileges. Typically, this means being part of the Administrators group or the Power Users group. If User Account Control (UAC) is active, it means launching Microsoft Dynamics GP with Administrative privileges.

To display this window, choose Microsoft Dynamics GP >> Tools >> Setup >> System >> Edit Launch File.

To change the name or location of a forms dictionary, select a product such as Microsoft Dynamics GP. Then edit the name or location of the forms dictionary in the field at the bottom of the Edit Launch File window.

Be sure that you have correctly specified the name and location of the forms dictionary. Otherwise, the accounting system may not start properly.


Modifier configurations

Two common configurations are used with the Modifier. One configuration has the forms dictionary stored locally on each workstation. In the other configuration, the forms dictionary is stored in a network location accessible by all workstations.

Storing the forms dictionary locally

In this configuration, each workstation has its own forms dictionary. Typically the forms dictionary is stored in the Data folder for the Microsoft Dynamics GP installation. This configuration is also used for single-user installations. This configuration has the following advantages:

  • Each workstation can have its own unique set of modifications.
  • Users can access the Modifier at any time.

It has the following disadvantage:

  • Modifications can’t easily be shared by multiple users. This issue can be partially resolved by making modifications on one workstation and then distributing the modifications to other workstations.

Storing the forms dictionary on a network

In this configuration, one forms dictionary is stored in a network location that can be accessed by each workstation. This configuration has the following advantages:

  • The same modifications are available to all users.
  • Any modifications users make are available to other users.

It has the following disadvantages:

  • Only one user can access the Modifier at one time.
  • All workstations are dependent on a single forms dictionary. If this dictionary is not available or becomes damaged, all users are affected.
  • Users can’t have different sets of modifications.

The configuration you choose depends upon how many modifications you want to make, whether individual users will be making modifications, and how you want to share modifications among users.


Accessing Modifications

You can control which users have access to the Modifier and which modifications specific users will see. Information about controlling access is divided into the following sections:

  • Accessing the Modifier
  • Accessing modified forms
  • Accessing third-party modifications
  • Removing modified forms


Accessing the Modifier

The predefined security task ADMIN_SYSTEM_009 for Microsoft Dynamics GP is used to control which users will be able to access the Modifier. Assign this security task to an existing role to grant access to the Modifier for users assigned to that role. You might also consider creating a new security role for the Modifier. Any user assigned to this new role will be able to access the Modifier.


Accessing modified forms

If you want to view a modified report from within the application, you must use the Alternate/Modified Forms and Reports window in Microsoft Dynamics GP to grant access. To open this window, choose Microsoft Dynamics GP menu >> Tools >> Setup >> System >> Alternate/Modified Forms and Reports.

Complete the following procedure to specify that a modified form should be used.

  1. Specify the ID.

Select the ID for the set of forms and reports you are modifying. The users that you want to view the modified version of the form must be assigned to use the set of modified/alternate forms and reports you selected. The User Security Setup window is used to specify the set of modified/alternate forms and reports for each user.

  2. Select the product containing the modified form.

This is the product in which the form was originally defined.

  3. Choose to display windows.

Choose Windows as the type of resource to display. The tree view will be filled with the modified forms available.

  4. Set the series.

By default, the Series drop-down list is set to All. You can choose to display resources from a specific series.

  5. Locate the modified form.

Expand the nodes in the tree view to locate the form that you modified. The forms are organized by series.

  6. Choose to use the modified form.

The original and modified versions of the form will be listed. Mark the modified version.

If you later wanted to use the original version of the form, you would mark the original form instead.

  7. Save the changes.

Click Save to save the changes.

To view modified forms, you must have either the Modifier or the Customization Site Enabler registered.

Be sure to activate security once you've made your selections by marking the Security option in the Company Setup window in Microsoft Dynamics GP. When you open the form to which you made modifications, the modified form will be opened in its place. You can verify that the modified form is being used by closely examining the title bar of the window. If the text in the title bar starts with a period, the modified window is being displayed.

Changes you made to core resources like strings and data types will be seen by all users. No additional configuration is required.


Accessing third-party modifications

You can use the Modifier to make changes to forms that are part of third-party products created with Dexterity. Dexterity is the tool used to create Microsoft Dynamics GP. If you have third-party products that integrate with Microsoft Dynamics GP, you will be asked which product you want to modify when you start the Modifier.

Modified forms

Any modifications you make to a third-party product will be stored in a separate forms dictionary for that product. To access these modified forms, you must select the third-party product in the Alternate/Modified Forms and Reports window. You can then choose to use the modified version of the form.

Alternate forms

Some third-party developers create alternate windows. These are Microsoft Dynamics GP forms that the third-party developer has enhanced and transferred to their own dictionary. By choosing the third-party dictionary when you start the Modifier, you can make modifications to these alternate windows.

When using the Alternate/Modified Forms and Reports window to set access to these reports, choose the modified version of the alternate report to display the modifications you made. For example, the following illustration shows how you would display a modified version of the alternate Country Codes form provided by the SmartList dictionary.


Removing modified forms

If you remove a modified form from Forms dictionary, be sure that you change the security settings to use the original form rather than the modified form. Otherwise, Microsoft Dynamics GP will not be able to properly access the form.


Packaging Modifications

When you have finished making modifications, you may want to distribute those modifications to other users. This portion of the documentation describes how you can use package files to distribute modifications. Information is divided into the following sections:

  • Package files
  • Package file import/export issues


Package files

Package files are special text files that are used to deliver customizations made with the Modifier, VBA, and the Report Writer. A developer can create a package file that contains their customizations, move the package file to the destination workstation, then import the customizations into the installation.

Package file contents

A package file can contain the following items:

Modified forms Forms that have been customized with the Modifier.

New or modified reports Reports that have been created or customized with the Report Writer.

VBA forms Forms that have VBA code attached.

VBA reports Reports that have VBA code attached.

VBA components User forms, code modules or class modules created with the VBA development environment.

References References to external components used by VBA. A package file cannot contain the actual components referenced by the VBA customization. Those components must be delivered separately.

Exporting a package file

Package files are created using the Customization Maintenance window. Complete the following procedure to create a package file.

  1. Open the Customization Maintenance window.

Open this window by pointing to Customize in the Tools menu and choosing Customization Maintenance.

  2. Select the components needed for the customization.

The Customization Maintenance window lists all of the components that have been customized with the Modifier, Report Writer or VBA. Select all of the components that are required for your customization.

To select non-contiguous items in the list, hold down the cCTRL key and click the items.

Click Export. A file dialog will appear, allowing you to specify the name of the package file. Be sure the file has the .package extension. The results of the export operation will be displayed in the status area at the bottom of the window.

Note that some global changes you make with the Modifier and Report Writer can’t be included in a package file. For instance, changes to picture resources or global data types won’t be included in package files.

Importing a package file

To import the contents of a package file, complete the following procedure.

  1. Open the Customization Maintenance window.

Open this window by pointing to Customize in the Tools menu and choosing Customization Maintenance.

  2. Open the Import Package File window.

Click Import in the Customization Maintenance window to display the Import Package File window.

  3. Select the package to import.

Click Browse to open a file dialog that allows you to select the package file you want to import. The contents of the package will be displayed in the Import Package File window.

An “X” in the Overwrite column indicates that a customized version of a component already exists for the system, and will be overwritten by the contents of the package file. Refer to Package file import/export issues for details about overwriting existing customizations.

If any of the package file items contain VBA code, the user importing them must have appropriate user privileges to update the .vba files in the Microsoft Dynamics GP installation. Typically, this means being part of the Administrators group or the Power Users group. If User Account Control (UAC) is active, it means launching Microsoft Dynamics GP with Administrative privileges.

Click OK to start the import process. If any errors occur during the import process, the Errors window will be displayed. The results of the import operation will also be displayed in the status bar of the Customization Maintenance window. To view the list of the last errors that occurred, click the Errors button in the status bar.

  4. Set access to any modified forms or reports that are part of the customization.

If necessary, use the security features in Microsoft Dynamics GP to grant access to any modified forms or modified reports that are part of your customization.


Package file import/export issues

There are some additional issues you need to be aware of when importing and exporting package files, concerning how customized resources are stored by Microsoft Dynamics GP.

Microsoft Dynamics GP contains forms, which are groups of windows, menus and other resources that work together for a common purpose. A form can have several windows, but you can make customizations to individual windows with the Modifier and VBA. When you export a form to a package file, you are exporting all of the windows in that form, not just the windows you modified or applied VBA code to.

This fact is important to keep in mind when you import a package file that contains customized forms. If a customized version of the form already exists in the system and you import another set of customizations for that same form, the original customizations will be overwritten. This occurs even if the customizations are made for different windows in the form.

A similar issue occurs for reports. If you’ve made customizations to a report, then import a package that contains customizations for that same report, the existing customizations will be overwritten.

A warning message is automatically displayed allowing you to cancel an import operation that will overwrite existing customizations.


Windows in Modifier

Button Items window
Button Values window
Color window
Data Type Definition window
Data Types window
Field Definition window
Field Definition window
Fields window
Form Definition window
Format Definition window
Formats window
Image Lookup window
Local Field Definition window
Menu Definition window
Messages window
Modified Forms window
Native Picture Definition window
Native Pictures window
Pattern window
Picture Definition window
Pictures window
Position Window window
Properties window
Resource Lookup window
Scrolling Window Layout window
Select a form to modify window
Static Picture Values window
Static Text Values window
String Definition window
Strings window
Toolbar window
Toolbox window
Window Layout window


Button Items window

Allows you to modify static values for push buttons and button drop lists. You can use text, pictures or both text and pictures on the buttons.

To display this window

Open a push button or button drop list data type. The Static Values drop-down list in the Data Type Definition window must be set to Text - Picture or Text - Native Picture. Click The Static Values lookup button.

Captions tab

The Captions tab allows to specify the text and images that will appear on the push button or button drop list. You can specify text, images or both text and images. The text or images displayed are determined by the state of the push button or button drop list.

  • In the normal, unclicked state, the Up caption and image are displayed.
  • When the push button or button drop list is clicked, the Down caption and image are displayed.
  • When the mouse is positioned over the push button or button drop list, the Over caption and image are displayed.
Caption

To specify a caption, type the text for the caption into the Up, Down or Over items in the Caption column.

Image

To specify a picture resource to use for the image, type the name of the picture or click a lookup button for the Up, Down or Over column. The Image Lookup window will be displayed, allowing you to select a picture to use. Any pictures you select will automatically be added to the image list for the push button or button drop list.

If you supply only the Up image or caption, the runtime engine will automatically generate the Down image or caption when the push button or button drop list is clicked..

The other fields in this tab are not used at this time.

Images tab

The Images tab lists all of the images that have been added to the image list for the push button or button drop list data type. When you use the Captions tab to specify pictures to use for the push button or button drop list, the pictures you select are automatically added to the image list.

To manually add pictures to the image list, click Add. The Image Lookup window will be displayed, allowing you to select a picture to add to the image list. To remove a picture from the image list, select it and click Delete.

Drop Items tab

The Drop Items tab allows you to specify static text items that will appear in a button drop list.

Item

The text string you want to add to the button drop list. To add a new static text value, type the value, then click Add. The item will be added to the list of values to be displayed in the button drop list.

Add

Inserts the value in the Item field into the list of static items. The new value will be inserted immediately before the selected value in the list. If no item is selected, the new item is added at the end of the list.

Delete

Removes the selected item from the list.

Replace

Replaces the selected item with the text in the New Value field.

Sort List

When marked, the text items added to the list will be sorted in alphabetical order at runtime. If this selection isn't marked, the values will be displayed in the order in which they were entered. The sorting process is not case-sensitive.


Button Values window

Allows you to set native pictures for a check box.

To display this window

Open a check box data type. The Static Values drop-down list in the Data Type Definition window must be set to Native Picture. Click the Static Values lookup button.


Color window

Use this window when setting color properties for fields and windows. Refer to the following topic for more information:

  • The Properties window

To display this window

In the Properties window, double-click a color property.


Data Type Definition window

Use this window to view or change a data type. A data type specifies how a field's data will be stored and displayed. Data types include a control type, keyable length, storage size, static values and a format.

To display this window

Click the Data Types button on the toolbar to open the Data Types window. Select a data type and click Open.


Data Types window

Displays a list of the data types that have been created for this dictionary. Use this window to select a data type to modify; then choose Open to open the Data Type Definition window to view or change the data type.

To display this window

Click the Data Types button on the toolbar.


Field Definition window

Allows you to view information about fields in a dictionary.

To display this window

Click the Fields button on the toolbar to open the Fields window. Select a field and click Open.


Fields window

Displays a list of the global fields that have been created for this dictionary. Use this window to select a field to view; then choose Open to open the Field Definition window to view information about the field.

To display this window

Click the Fields button on the toolbar.


Form Definition window

Allows you to make changes to a modified form. Using this window, you can change windows and menus, and view a list of the tables attached to a form. Refer to the following topics for more information:

  • Selecting Forms to Modify
  • Modifying Windows
  • Modifying Menus

To display this window

Click the Forms button on the toolbar to open the Modified Forms window. Select a form and click Open.


Format Definition window

Use this window to view or change the format applied to a data type to control how the data type's information will be displayed. The display characteristics determined by formats include the number of decimal places allowed in currency data types, the types of characters that can be entered for string data types and whether to display currency and negative symbols for integer and currency data types. Refer to the following topic for more information:

  • Formats

To display this window

Choose Formats from the Resources menu to display the Formats window. Select a format and click Open, or click New to create a new format.


Formats window

Displays a list of the data formats that have been created for this dictionary. Use this window to select a format to modify; then choose Open to open the Format Definition window to view or change the format.

To display this window

Choose Formats from the Resources menu.


Image Lookup window

Use this window to select an image for a push button or button drop list.

To display this window

Click New in the Button Items window.


Local Field Definition window

Use this window to view local field definitions or to create new local fields.

To display this window

In the Toolbox window, select Local Fields in the drop-down list. Select a field and click Open, or click New to create a new local field.


Menu Definition window

Use the Menu Definition window to edit menus and menu items: Refer to the following topics for more information:

  • Opening a menu definition
  • Editing menu items

To display this window

Click the Menus tab in the Form Definition window. Select a menu and click Open.


Messages window

Use this window to modify messages that appear in the accounting system. Refer to the following topic for more information:

  • Finding messages

To display this window

Choose Messages from the Resources menu.


Modified Forms window

This window lists all of the forms that have been added to the Forms dictionary. You can make modifications to any of the forms appearing in this list. Refer to the following topics for more information:

  • Finding a form name
  • Creating a modified form

To display this window

Click the Forms button on the toolbar.


Native Picture Definition window

Use this window to create or edit native pictures in the dictionary. Native pictures are pictures that are native to the operating system in which they're created.Native pictures are used on push buttons and visual switches. Native pictures can be displayed only in the operating system in which they were created. This window also allows you to synchronize two native pictures from different operating systems, so that the appropriate picture will be used for each operating system. Refer to the following topics for more information:

  • Creating native pictures
  • Synchronizing native pictures
  • Using native pictures

To display this window

Choose Native Pictures from the Resources menu to display the Native Pictures window. Click New to create a new native picture or Open to open an existing native picture.


Native Pictures window

Displays a list of the native pictures that have been created for this dictionary. Use this window to select a native picture to modify, or to open the Native Picture Definition window to create a new native picture.

To display this window

Choose Native Pictures from the Resources menu.


Pattern window

Use this window when setting pattern properties for fields and windows. Refer to the following topic for more information:

  • The Properties window

To display this window

In the Properties window, double-click a pattern property.


Picture Definition window

Allows you to add pictures to the picture library. A picture must be added to the library before it can be attached to a data type as a static value. Refer to the following topics for more information:

  • Adding a picture to the picture library
  • Using a picture from the picture library

To display this window

Choose Pictures from the Resources menu to display the Pictures window. Click New to create a new picture or Open to open an existing picture.


Pictures window

Allows you to maintain the picture library. From this window you can add a new picture, modifying an existing picture, or remove pictures from the dictionary. This window is also used when you use the Picture tool to insert pictures into the Layout window.

To display this window

Choose Pictures from the Resources menu.

Select the Picture tool in the Toolbox window and click in the Layout window.


Position Window window

Use this window to set the opening position of windows. Refer to the following topic for more information:

  • Positioning the window

To display this window

Choose Position Window from the Layout menu.


Properties window

Allows you to set characteristics of the window and the objects in the window.

To set a property, use the arrow tool to select the window or an object in the window. You can also choose an object by selecting it in the drop-down list at the top of the Properties window. An icon will appear next to the drop-down list to indicate the type of object selected.

Click the tab that indicates which type of property you want to view: Object or Visual. To set a property, select it in the list and then change its value in the settings box. Setting the property value involves choosing a value from a drop-down list, typing a value, or using a lookup. Some properties can't have their values changed.

Double-clicking a property in the properties list is a shortcut to setting its value. For instance, double-clicking a property whose value is set with a drop-down list will set the property to the next value in the list.

Refer to the following topics for more information:

  • The Properties window
  • Window properties
  • Field properties
  • Drawn object properties
  • Scrolling window properties

To display this window

When the Layout window is open, choose Properties from the Layout menu.


Resource Lookup window

This window allows you to attach one resource to another. It displays a list of resources of the appropriate type, depending upon the selection you made to open the window. The title of this window will vary depending upon the resource you are trying to attach. For example, if you were attaching a format to a data type, the window would be titled "Format Lookup."

To display this window

This window is displayed when you click a Lookup button to attach a previously defined resource to another resource; for instance, if you click the Format lookup button in the Data Type Definition window.


Scrolling Window Layout window

Allows you to customize the appearance of scrolling windows. This window functions much like the Window Layout window. To display the layout window for a scrolling window, double-click the scrolling window in the window layout. To add and manipulate fields and other objects in the Scrolling Window Layout window, use tools from the Toolbox window. Set properties for the scrolling window or objects in it using the Properties window.

When you create the layout for a scrolling window, you are creating the layout for only one line of the scrolling window. This line is drawn in the scrolling window once for each record in the linked table, until the scrolling window is full.

Refer to the following topics for more information:

  • The layout area
  • Scrolling window properties
  • Adding fields to a scrolling window

To display this window

Select a scrolling window in the Window Layout window. Choose Open Scrolling Window from the Tools menu.


Select a form to modify window

Displays a list of all original forms in the dictionary. Select a form, then click OK to make a copy of the form. The Form Definition window will appear, allowing you to make changes to the form. Refer to the following topics for more information:

  • Finding a form name
  • Creating a modified form

To display this window

Click the Forms button on the Toolbar to display the Modified Forms window. Click New.


Static Picture Values window

Allows you to attach pictures to the data types that use static picture values. Refer to the following topic for more information:

  • Static values

To display this window

In the Data Type Definition window, click the Static Values lookup button for the check box or visual switch data type.

In the Local Field Definition window, set the Static Type to Picture and click the Static Type lookup button.


Static Text Values window

Allows you to view or change static text values for data types that use them, such as list boxes, drop-down lists and multi-select list boxes. Refer to the following topic for more information:

  • Static values

To display this window

In the Data Type Definition window, the Static Values field must be displaying Text. Then click the Static Values lookup button.

In the Local Field Definition window, set the Static Type to Text and click the Static Type lookup button.


String Definition window

Allows you to modify strings in the current dictionary. When you change the string in this window, it will be changed everywhere it is used in the dictionary, including text prompts, static text used for data types, menu items, and so on. If you don't want to change all occurrences of a string, modify each individual string where it occurs. Refer to the following topics for more information:

  • Using strings
  • Modifying a string

Changing strings using the Modifier will only affect the strings that appear in windows. To change strings that appear on reports, you must use the Report Writer.

To display this window

Choose Strings from the Resources menu to display the Strings window. Select a string and click Open.


Strings window

Allows you to view a list of the strings in the current dictionary. Each string, such as a field prompt or window title, is stored only one time in the dictionary. If a string is used multiple times, each occurrence refers to the same string resource. This allows you to change all occurrences of a string in one step instead of changing the same string in each place it occurs. Refer to the following topics for more information;

  • Using strings
  • Modifying a string

Changing strings using the Modifier will only affect the strings that appear in windows. To change strings that appear on reports, you must use the Report Writer.

To display this window

Choose Strings from the Resources menu.


Toolbar window

The Modifier toolbar appears across the top of the main window. Each button that appears represents a fundamental resource that you can view or edit. The following table describes each button.

Button | Description
 | Opens the Data Types window, where you can view or edit existing data types.
 | Opens the Fields window, where you view a list of fields in the application.
 | Opens the Modified Forms window, where you can view a list of the modified forms in the application. You will also use this window to create new modified forms.


Toolbox window

Allows you to create new fields, place fields and other items in the window layout area, and arrange existing items.

The Toolbox window's Layout and Arrange tabs let you toggle between two different sets of tools. Tools in the Layout tab help you place information in the layout area, while tools in the Arrange tab are used to arrange selected items in the layout area. The Pos and Size fields at the bottom of the Toolbox window indicate the position and size of the object selected in the layout area.

Refer to the following topics for more information:

  • The Toolbox
  • Creating local fields
  • Using the Toolbox

To display this window

With the Window Layout window open, choose Toolbox in the Layout menu.


Window Layout window

Allows you to customize the appearance of windows. A window consists of the visual area displayed on the screen that contains editable fields, interactive controls and static items such as text or pictures.

The layout window and toolbox use a graphics metaphor you may already be familiar with: an assortment of tools you can use for drawing and creating text objects; a built-in grid that allows easy alignment of objects on the window; moveable objects in a layout much like an object-oriented drawing program; and standard cut-copy-and-paste techniques you can use to import graphics you create in other applications.

Refer to the following topics for more information:

  • Opening a window layout
  • The Toolbox
  • The layout area
  • The layout grid
  • The Properties window
  • Previewing a window
  • Setting the tab sequence
  • Positioning the window
  • Adding fields to the window

To display this window

Open the form definition that contains the window you want to display. Select the window and click Open.


Glossary

3D highlight

Accelerator key

Access key

Alphanumeric

Array field

Array index

Auto-linked table

Big line item

Button drop list

Cancel property

Cascading menus

Change flag

Check box

Combo box

Component

Composite

Control type

Core resources

Customization site enabler

Data type

Default property

DefaultDblClick property

Definition window

Dictionary

Drop-down list

Element

Field

Focus

Form

Format

Format field

Format string

Forms dictionary

Global field

Group box

Keyable length

Keyboard equivalent

Launch file

Layout window

List box

List field

Local field

Menu

Menu item

Messages

Modal dialog

Modified form

Multi-select list box

Native pictures

Original form

Package files

Password

Picture library

Pixel

Point size

Progress indicator

Prompt

Property

Push button

Radio button

Radio group

Relative decimal position

Replacement marker

Resource descriptions tool

Resource list window

Runtime engine

Scrolling window

Series

Small line item

Static picture value

Static text value

Storage size

Storage type

String resources

Synchronize

Tab sequence

Toolbox

Visual Basic for Applications (VBA)

Visual Studio Tools for Microsoft Dynamics GP

Window

Window field

WordWrap

Zoom pointer


Copyright notice

Copyright © 2012 Microsoft Corporation. All rights reserved.

Limitation of liability

This document is provided “as-is”. Information and views expressed in this document, including URL and other Internet Web site references, may change without notice. You bear the risk of using it.

Some examples depicted herein are provided for illustration only and are fictitious. No real association or connection is intended or should be inferred.

Intellectual property

This document does not provide you with any legal rights to any intellectual property in any Microsoft product.

You may copy and use this document for your internal, reference purposes.

Trademarks

Microsoft, Dexterity, Microsoft Dynamics, Visual Basic, Visual Studio, Windows, and Windows Vista are trademarks of the Microsoft group of companies. FairCom and c-tree Plus are trademarks of FairCom Corporation and are registered in the United States and other countries.

All other trademarks are property of their respective owners.

Warranty disclaimer

Microsoft Corporation disclaims any warranty regarding the sample code contained in this documentation, including the warranties of merchantability and fitness for a particular purpose.

License agreement

Use of this product is covered by a license agreement provided by Microsoft Corporation with the software product. If you have any questions, please call the Microsoft Dynamics GP Customer Assistance Department at 800-456-0025 (in the U.S. or Canada) or +1-701-281-6500.

Publication date

July 2012


Glossary

3D highlight

An Appearance property setting for push buttons that causes them to have a flat appearance until the mouse pointer is moved over the button. Then the button appears with a 3-D border.

Accelerator key

A key or set of keys on the keyboard that can be used as a “shortcut” to select a menu or menu option rather than using the mouse.

Access key

An underlined character in a menu name, menu item name or push button that allows users to select the item by typing the underlined character or by holding down the ALT key and typing the character.

Alphanumeric

A combination of numbers and letters.

Array field

A field containing multiple occurrences of the same type of information. The individual pieces of information stored by an array field are called elements.

Array index

The number designating a specific element within an array field.

Auto-linked table

The table specified in the AutoLinkTable window property. You can use the Modifier to add fields from the auto-linked table to the window.

Big line item

The area containing the fields that will be displayed for a scrolling window in expanded mode. See also Small line item.

Button drop list

A control type used to define data types that allow a user to select one item from a list of values. A series of static text values will appear, or “drop” when a user clicks a field that uses this control type.

Cancel property

A property that can be applied to a push button window field. If this property is set to true, pressing the ESC key produces the same result as clicking the push button.

Cascading menus

Submenus that appear to the right of a menu item.

Change flag

A boolean value associated with each form or window in an application. If the contents of the form or window change, the change flag is set to true, indicating the contents have changed.

Check box

A control type used to define data types that allow users to mark or unmark an option.

Check boxes have boolean storage types.

Combo box

A control type used to define data types that allow users to enter a text value or choose that value from a list.

The items in the list are determined by the static text values in the data type definition.

Component

One field of a composite field.

Composite

A group of fields and their associated data types that form a single data type. Composite data types are defined by the composite control type and the fields that make up the composite.

Control type

The main characteristic of a data type, controlling the type of information that can be stored in fields that use that data type, and some aspects of how the information will be displayed. Commonly-used control types are push button, integer, check box, date and currency.

Core resources

Resources such as strings, data types or global fields that are used by several parts of an application. When the forms dictionary is created, the core resources in the application dictionary are copied to it.

Customization site enabler

A Microsoft Dynamics GP module that can be registered to allow access to modified forms without having to register the Modifier.

Data type

A resource that defines the characteristics for a field, such as its keyable length, control type (push button, check box, string and so on) and format. A single data type can be applied to several fields, but a field can have only one data type applied to it.

Default property

A property that can be applied to a push button window field. If this property is set to true, pressing the ENTER key or double-clicking a list box or scrolling window with the DefaultDblClick property set to true causes the push button to be clicked.

DefaultDblClick property

A property for list box fields, non-native list box fields, and scrolling windows. Double-clicking the list box or a line in a scrolling window with this property set to true causes the push button whose Default property set to true to be clicked. See also Default property.

Definition window

A window that allows you to create or edit a resource and specify its functional characteristics.

Dictionary

A group of resources that, when interpreted by the runtime engine, present a complete functioning application.

Drop-down list

A control type used to define data types that allow users to select one item from a list.

A series of static text values will appear, or “drop,” when a user clicks a field with this control type. The integer value corresponding to the position of the item chosen, not the item’s static text value, is stored when the user’s selection is saved.

Element

One of the fields in an array field.

Field

A field contains a single piece of information used by an application. A field can be displayed on a window or stored in a table. The kind of information the field displays or stores depends on the data type associated with it. See also Global field and Local field.

Focus

The indicator that shows the object being controlled in the current window.

Form

A collection of windows, menus and other resources that function together for a common purpose.

Format

The extra characters, spacing and attributes that can be applied to a data type when data is entered or displayed.

Format field

An integer field that specifies the format to use for a string or currency field.

Format string

A data “mask” used for string and composite formats. The format string allows extra characters to appear in a field without affecting the way data in the field is stored.

Forms dictionary

The dictionary that stores user-modified resources. This dictionary is created when the Modifier is accessed for the first time. Only copies of a dictionary’s resources are stored in the forms dictionary.

Global field

A field that can be displayed in windows and also stored in tables. The characteristics of global fields can be viewed with the Field Definition window. See also Local field.

Group box

A box drawn around a group of check boxes or other fields, using the rectangle tool, to visually group the items.

Keyable length

The number of characters that can be typed in a field.

Keyboard equivalent

A key combination that will activate a menu item as an alternative to selecting it with the mouse.

Launch file

A file that is used to start an application with the runtime engine. This file stores the location of the dictionaries that will be used, including the application dictionary and the forms dictionary.

Layout window

A window in the Modifier that allows you to design the layout of a window or scrolling window.

List box

A control type used to define data types that allow users to select one static text value from a list.

The list will appear with scroll bars if the information in the list is greater than the size of the list box field when it’s added to the Layout window. An integer position - not the static text - for the corresponding selection in a list box is stored when the selection is saved.

List field

Any field that uses a list box, drop-down list, multi-select list, button drop list, combo box or visual switch data type.

Local field

A field that’s available only within the form in which it’s created. Local fields are used as window fields. The Modifier can create local fields. See also Global field.

Menu

One of the items displayed on the menu bar across the top of the screen.

Menu item

One of the selections associated with a particular menu.

Messages

A type of resource that associates a text string with an ID. Messages are used to store the text that provides information or prompts a user to make a selection. Messages are also used to store other strings, such as the names of reports or the items that appear in the toolbar buttons.

Modal dialog

A window that contains no operating system controls and can’t be resized. Modal dialogs are used when you require the user to perform an action before continuing.

Modified form

The copy you make of the original form. Modified forms are added to the Forms dictionary. You can select the modified form and customize the windows belonging to it. See also Original form.

Multi-select list box

A control type used to define fields from which one or more static text values can be selected. The list will appear with scroll bars if the number of items in the list are greater than the size of the field when it was added to the Layout window.

Native pictures

Picture objects that are specific, or native, to a particular operating system. Metafiles and bitmap images are used as native pictures on Windows. Native pictures must be used for graphics that appear on push buttons and visual switches.

Original form

An unmodified form that is stored in its original dictionary. You must make a copy of an original form before you can make modifications to it. See also Modified form.

Package files

Special text files that are used to deliver customizations made with the Modifier, VBA, and the Report Writer.

Password

A field property that allows you to hide entries in a field, such as when a password is being entered. If this property is set to true, an X will be displayed in place of each character a user enters, so that no one else can read the entry from the screen.

Picture library

A feature in the Modifier that allows you to store graphics in a generic format that can be used on any supported platforms.

Pixel

The smallest graphical element displayed on a monitor. The pixel is the smallest unit of measurement in layout windows. You can move objects one pixel at a time within a layout window by using the arrow keys on the keyboard.

Point size

The vertical size of a font. There are 72 points to an inch.

Progress indicator

A control type used for fields that shows the progress of processes in the application.

Prompt

Text in a window that shows the user the information that is displayed or can be entered in the corresponding field or fields.

Property

An attribute that can be assigned to fields, windows or graphical objects displayed in a window layout. For example, a window with the Resizeable property set to false cannot be resized by the user.

Push button

A control type used to define data types for buttons users can click to accomplish tasks.

Static text or pictures can be used to indicate the button’s function.

Radio button

A control type used to define data types that allow a single selection to be made from a group of two or more selections.

Radio buttons must be used with a radio group.

Radio group

A control type that’s used to group related radio buttons and store the value of the selected button.

A radio group’s value is stored as an integer corresponding to the selected radio button’s position in the tab sequence, beginning with 0. For instance, if the second radio button in the tab sequence is selected, the radio group’s value is 1.

Relative decimal position

An option for currency formats that sets the number of decimal digits that will be displayed to the indicated value plus the number of decimal places specified by the operating system. If your operating system displays two decimal positions and you specify three decimal digits for the format in the Format Definition window, the field will display a total of five decimal places.

Replacement marker

A placeholder (% followed by a number) that indicates where items may be substituted in messages.

Resource descriptions tool

A tool that displays information about the current dictionary’s fields, windows and tables.

Resource list window

A window in the Modifier that allows you to view all the resources of a particular type, such as fields.

Runtime engine

An application that’s used to interpret a dictionary. When a user starts an application, the runtime engine uses the resources in the dictionary to present a functioning application.

Scrolling window

A special type of window that allows the user to “scroll” through items.

Series

A predefined category to which form and table resources are assigned. Series allow categorization of resources.

Small line item

The area containing the fields that will be displayed when a scrolling window is in standard mode. When a scrolling window is in expanded mode, additional fields below the small line item mark, but above the big line item mark will be displayed. See also Big line item.

Static picture value

A picture that’s displayed as part of a data type, such as the picture on a button drop list.

Static text value

Text that’s displayed as part of a data type, such as the name of a push button or the items in a list box.

Storage size

The size, in bytes, used store the information in a field. The storage size is specified in the field’s data type. It can’t be changed by the Modifier.

Storage type

One of the standard forms used to store the data in a field. The storage types are: boolean, integer, long, currency, currency (variable), string, text, date, and time. The control type determines which storage type is used to store the data in the field.

String resources

Sequences of up to 79 characters used throughout a dictionary for window names, field prompts and static text values.

Synchronize

The process of specifying the native picture on each platform that should be used as the static value for a single data type. When two pictures are synchronized, the Modifier will assign them the same internal ID. Thereafter, when a synchronized picture is displayed, the native picture that’s appropriate to the current platform will be displayed.

Tab sequence

The order in which the focus moves from one field to the next field when the user presses the TAB key.

Toolbox

A window that opens in conjunction with the Window Layout and Scrolling Window Layout windows. It contains tools used to place and arrange items in the layout area.

Visual Basic for Applications (VBA)

A development system created by Microsoft that can be embedded into applications. VBA is embedded into the Modifier, where it provides additional customization capabilities.

Visual Studio Tools for Microsoft Dynamics GP

A development toolset based on the Microsoft .NET framework that can be used to create integrations for Microsoft Dynamics GP. Microsoft Visual Studio is the development tool used to create these integrations.

Window

The work area used to enter and display information in a application.

Window field

A global or local field that has been added to a window layout.

WordWrap

A property for text fields that causes text to automatically continue to the next line when it extends beyond the right edge of the field.

Zoom pointer

A special cursor that appears when the pointer is over a push button field that has the Zoom property set to true. In Microsoft Dynamics GP, clicking the mouse when this pointer is over the field enables users to “zoom” to the window where records for the field can be added.


Picture Definition window: Fields

Picture Name

Displays the name used to store the picture.

Picture

Click in this field and choose Paste from the Edit menu to transfer a picture you've previously copied to the Clipboard. Pasting an image cannot be undone; if you make a mistake, click Cancel to close the Picture Definition window without saving changes.


Picture Definition window: Buttons

OK

Saves your entries and closes the window.

Cancel

Clears all new entries and closes the window without saving changes.


Pictures window: Fields

Pictures

Displays the list of pictures that have been defined for this dictionary.


Pictures window: Buttons

New

Opens the Picture Definition window, allowing you to add a new picture to the picture library.

Open

Opens the Picture Definition window and displays the picture selected in the list.

Delete

Removes the selected picture from the dictionary. You can delete only pictures that were created with the Modifier.

OK

This button appears on the window only when you are inserting a picture into the Layout window. Clicking OK inserts the selected picture into the Layout window.

Cancel

This button appears on the window only when you are inserting a picture into the Layout window. Clicking Cancel closes the Pictures window without inserting the selected picture.


Position Window window: Fields

Pos

Displays the window's position, measured in pixels, relative to the top, left corner of the screen, beginning below the menu bar. The first set of parentheses contains the coordinates of the upper left corner of the window. The second set contains the coordinates of the lower right corner of the window. This field is automatically updated as you move the Position Window window on the screen.

Size

Displays the total width and height of the window, measured in pixels.


Position Window window: Buttons

OK

Saves the current window position and closes the window.

Cancel

Closes the window without saving the window position.


Button Values window: Fields

Native Pictures

Displays a list of native pictures available in the current dictionary.

Button Up Image

Displays the name of the native picture to be displayed when the control isn't being clicked.

Button Down Image

Displays the name of the native picture to be displayed when the control is being clicked.


Button Values window: Buttons

Add

Places the picture selected in the Native Pictures list in the Button Up Image or Button Down Image field.

Remove

Clears the current button up or button down image.

OK

Saves your entries and closes the window.

Cancel

Closes the window without saving changes.


Color window: Fields

Color tab

Lists available standard colors. You can choose System as a color choice when you specify the FontColor, BackColor or LineColor visual properties for objects. The runtime engine supports the use of system colors for various controls. If system colors are not supported for a particular property or operating system, a default color is used.

The following chart lists the color properties, and shows the operating system color setting or default color that will be used when the color property is set to System.

Property | Description
FontColor | Window font color
BackColor (For editable fields) | Window color when editable; 3D Object color when not editable
BackColor (For static items) | 3D Object color
LineColor | Based upon 3D Object color

System tab

Lists the system color categories available for the application. The runtime engine maintains a list of system color categories that you can assign to window items. For instance, "System - Button Text" is one of the system color categories. You can set the color properties for a window element to used the color associated with a specific system color category.

The color used for each system color category is determined by the settings in the Display Options window in Microsoft Dynamics GP.

Preview

Displays a sample of the selected color.


Color window: Buttons

OK

Applies the selected color and closes the window.

Cancel

Closes the window without selecting a color.


Data Type Definition window: Fields

Data Type Name

Displays the name of the data type. Typically, the name indicates the characteristics of the data type, such as the control type used or the size of the data type. For instance, the name String30 indicates the data type has a string control type that can display 30 characters.

Control Type

Specifies the function of the data type, indicating how it will display and store data. Other fields in this window may be available or unavailable, depending on the control type selected. Refer to Control types for a description of each control type.

Keyable Length

Displays the number of characters that can be typed in the field by the user. Control types such as currency, integer and string have a keyable length.

Storage Size

Displays the amount of storage space, in bytes, that the field will require when stored in a table. The storage size is calculated automatically and can't be changed. The storage size for strings is typically larger than the minimum amount calculated to allow room for expansion, in case you need to increase the keyable length of the data type.

Allow Odd Length

Allows string data types that have an odd-length storage size, rather than appending an extra byte to make the storage size even. For example, if this selection is marked and the keyable length of the string is 10, the storage size would be 11. If this selection is not marked, the storage size would be 12. This field is only available when the control type has been set to string. This option isn’t used in Microsoft Dynamics GP.

Decimals

Specifies the number of decimal places for Variable Currency control types. This field isn’t used for standard Currency control types.

Static Values

Allows you to specify text or picture items that will always be associated with the data type. For instance, a button label, such as "Save", may be associated with a push button data type. The phrase Text, Picture, Native Picture, Text - Picture, or Text - Native Picture will be displayed, indicating the type of static value to be used with this data type. To view or change the static values associated with the data type, click the Static Values lookup button. A window will appear, allowing you to enter or select static values. Refer to the topic Static values for more information about defining static values.

Format

Attaches a predefined data format to the data type. The format defines data display and entry characteristics for string, currency, composite and integer data types.

Composite

Shows the name of the composite resource associated with a composite data type. A composite is a group of fields and their associated data types that are combined to form a single data type.

Auto Add Field

This field isn’t available in the Modifier.

Call Component Scripts

This field isn’t available in the Modifier.


Data Type Definition window: Buttons

Static Values lookup

The function of this button depends on the selection in the Static Values field:

Text: Opens the Static Text Values window, allowing you to create and modify static text values.

Picture: Opens the Static Picture Values window, allowing you to create and modify picture values.

Native Picture: Opens the Button Values window, allowing you to create and modify native picture values.

Text - Picture: Opens the Button Items window, allowing you to create and modify text and picture values.

Text - Native Picture: Opens the Button Items window, allowing you to create and modify text and native picture values.

Format lookup

Opens the Resource Lookup window, which displays a list of formats you can apply to the data type.

Composite lookup

This button is not available in the Modifier.

OK

Saves your entries and closes the window.

Add

This button is not available in the Modifier.

Cancel

Closes the window without saving changes.


Data Types window: Fields

Data Types list

Displays a list of data types in the current dictionary.


Data Types window: Buttons

New

This button is not available in the Modifier.

Open

Opens the Data Type Definition window, allowing you to modify the selected data type.

Delete

This button is not available in the Modifier.


Field Definition window: Fields

Field Name

Displays the name of the field.

Physical Name

The physical name is a shortened version (up to 24 characters) of the field name, and is used as the column name if the field is used in a SQL table.

Lookup Form

Displays the name of the lookup form that's attached to the field. When a lookup form is attached to the field and the focus is on the field, the user can open the attached form by choosing Lookup from the Help menu.

Array Size

An array field contains multiple occurrences of the same type of information. The individual pieces of information stored by the array field are referred to as elements. The array size of a field indicates the number of elements that will be included in the array field. The value 0 (zero) indicates the field is not an array.

Data type

Displays the data type associated with this field. The data type, which specifies most of the characteristics of the field, can be used by other fields, as well.

To view or change the settings for a data type, select a data type and click Open. The Data Type Definition window will appear, allowing you to view or change the options for the data type.


Field Definition window: Buttons

Lookup Form lookup

This button is not available in the Modifier.

Open

Opens the Data Type Definition window, allowing you to modify the selected data type. If you modify the data type definition here, it will be changed for all fields that use the data type, not just the current field.

OK

Closes the window.

Add

This button is not available in the Modifier.

Cancel

This button is not available in the Modifier.


Fields window: Fields

Fields list

Displays a list of fields in the current dictionary.


Fields window: Buttons

New

This button is not available in the Modifier.

Open

Opens the Field Definition window for the selected field.

Delete

This button is not available in the Modifier.


Form Definition window: Fields

Form Name

Displays the name used to store and access the form.

Series

Displays the series for the form. The form series groups related forms together using categories like Sales, Financial and System.

Windows tab

Displays the windows that have been created for this form and allows you to open a window layout.

The first window name in the list is the main window for this form - the window that will appear first when the form is opened. When you're using this form in Microsoft Dynamics GP, closing the main window will close this form.

Tables tab

Displays the tables attached to the form.

Menus tab

Displays the menus that have been created for this form, and allows you to edit menu names or items. The menus that appear in this window are visible only when a window attached to the form is active.

The order menus are listed in the window, top to bottom, will be the order they are displayed, left to right, on the menu bar. If you want to change the position of a menu, select its name in the list, and click the Up or Down buttons.


Form Definition window: Buttons

Windows tab

Open

Opens the layout window for the selected window.

Menus tab

Open

Opens the Menu Definition window, allowing you to edit an existing menu definition.

Up

Moves the selected menu up one position in the list. In Microsoft Dynamics GP, the menu will appear one position to the left of its original location on the menu bar.

Down

Moves the selected menu down one position in the list. In Microsoft Dynamics GP, the menu will appear one position to the right of its original location on the menu bar.

OK

Saves your entries and closes the window.

Cancel

Closes the window without saving changes.


Format Definition window: Fields

Format Name

Displays the name of the format definition. Typically, the name indicates the data type the format is applied to. For instance, the name Phone_Number indicates this format will be applied to the Phone_Number data type.

Format Type

Specifies the type of data to which the format will be applied.

  • Currency - Displays options for monetary values.
  • Numeric - Displays options for numbers other than currency amounts.
  • String - Displays options for text strings.
  • Composite - Displays options for composite data types. Each component of the composite will take its format from the format attached to its respective data type.

Setting the type determines which additional format options are available in this window. The topic Formatting options describes the various options available for each type of format.

Alignment

Specifies whether information in the field will be left-, center-, or right-aligned.

Fill

If the format uses a format string, this field specifies whether unused positions in the field contents will be filled with asterisks, spaces or zeros.

Decimal Digits

Specifies the number of decimal positions that will be displayed for the number. The value can be 0 to 5 for standard currency data types. It can be 0 to 15 for variable currency data types. The effect this setting will have depends on the setting of the Relative Decimal Position option in this window. This doesn't affect the number of decimal places that are stored in the table; it specifies only what is displayed in windows.

Negative Symbol

Specifies the type of negative symbol that will be displayed in the field. You can specify that negative amounts will be preceded by a minus sign (-) or the letters CR, will be enclosed in parentheses, or will be displayed according to the operating system settings.

String Options

Options in this group control how text strings will be displayed. These options will be unavailable if the format type is currency or numeric. Refer to the topic Formatting options for a description of each option.

Numeric/Currency Options

Settings in this group control how numbers and monetary values will be displayed. These options will be unavailable if the format type is string or composite. Refer to the topic Formatting options for a description of each option.

Format String

Allows you to add a format string to the list of available format strings for this format definition. Type the string in this field and use the Insert button to add it to the list of available strings. Use uppercase Xs (XXX) to indicate the position of characters stored in the field. All other characters in the format string, such as parentheses, static text and so on, will be displayed in windows or printed on reports just as they are entered here.

If you're entering a format string for a composite data type, use numerals to indicate the position of each composite component. For example, a composite that contains three components could have this format string: #11111-222-333333.

Format Strings

Displays the format strings used for this format definition.


Format Definition window: Buttons

Insert

Inserts the string in the Format String field into the Format Strings list. The string will be inserted below the selected string.

Remove

Removes the selected string from the Format Strings list.

OK

Saves the format definition and closes the window.

Cancel

Closes the window without saving changes.


Formats window: Fields

Formats list

Displays a list of formats in the current dictionary.


Formats window: Buttons

New

Opens the Format Definition window, allowing you to create a new format.

Open

Opens the Format Definition window, allowing you to modify the selected format.

Delete

Deletes the selected format.


Image Lookup window: Fields

Image

Lists the native pictures that can be selected.

Preview

Shows a preview of the selected image.


Image Lookup window: Buttons

OK

Adds the selected image to the button drop list and closes the window.

Add

Adds the selected image to the button drop list, but leaves the window open.

Cancel

Closes the window without selecting an image.


Local Field Definition window: Fields

Field Name

Displays the name of the local field. When the field is placed in the layout area, the prefix (L) will be added to the name.

Lookup Form

Displays the name of the form that will be opened when the focus is in the field. This field is not accessible with the Modifier.

Array Size

Indicates the number of array elements in this field. If the local field isn't an array, this field's value will be 0.

Local/Global

Local indicates that the data type is defined in this window. Global indicates that a global data type created in the Data Type Definition window is used for this local field.

Control Type

Specifies the control type of the local field. A control type is a data display and storage method, based on basic storage types such as integer, long integer, boolean and string. Some control types have the same storage type but are displayed in different ways; for instance, drop-down lists and list boxes are both stored as integers, but display data differently. Other fields in this window may be available or unavailable, depending on the control type selected. This list is available only when Local is marked in this window. Refer to Control types for a description of each control type.

Keyable Length

Displays the number of characters that can be typed in the field by the user. Control types such as currency, integer and string have a keyable length.

Storage Size

Displays the amount of storage space, in bytes, required to store the value. For most control types, the storage size is calculated by Microsoft Dynamics GP and can't be changed.

For variable currency fields, you can set the storage size to 8, 10 or 12 bytes. Set the size to be large enough to hold the number of digits specified in the keyable length.

Allow Odd Length

This option isn’t available in the Modifier.

Decimals

Specifies the number of decimal places for Variable Currency control types. This field isn’t used for standard Currency control types.

Static Type

Allows you to specify text or picture items that will always be associated with the local field. You can set this field to Text, Picture or Native Picture, indicating the type of static value to be used with this local field. To view or change the static values associated with the local field, click the Static Type lookup button. A window will appear, allowing you to enter or select static values. Refer to the topic Static values for more information about defining static values.

Format

Attaches a predefined data format to the local field. The format defines data display and entry characteristics for string, currency, composite and integer fields. Click the lookup button to display a list of available formats. This field is unavailable when the data type is Global, since the global data type definition already includes format information.

Data Type

Specifies a global data type for this local field. This field is available only when the data type is Global.


Local Field Definition window: Buttons

Static Type lookup

The function of this button depends on the selection in the Static Type field:

Text: Opens the Static Text Values window or the Button Items window, allowing you to create and modify static text values.

Picture: Opens the Static Picture Values window, allowing you to create and modify picture values.

Native Picture: For check boxes, opens the Button Values window. For visual switches, opens the Static Picture Values window.

Text - Picture: For push buttons and button drop lists, opens the Button Items window.

Text - Native Picture: For push buttons and button drop lists, opens the Button Items window.

This field is unavailable if the data type is global, since globally-defined data types typically already have static values.

Format lookup

Opens the Resource Lookup window, allowing you to choose the format that will be applied to the field contents. This field is unavailable when the data type is Global, since the global data type definition already includes format information.

Data Type lookup

This field is available only when the data type is Global. Clicking this button opens the Data Type Definition window, allowing you to view the characteristics of the data type.

OK

Saves the local field and closes the window.

Add

Saves the local field, but doesn’t close the window.

Cancel

Closes the window without saving changes.


Menu Definition window: Fields

Menu name

This is the name that is used within Microsoft Dynamics GP to refer to the menu.

Display name

This is the name that appears when the menu is displayed in the menu bar. The menu bar area is limited, so keep menu names as short as possible.

You can define an access key for the menu by placing an ampersand (&) in the menu display name. The ampersand won't be displayed in the menu name. Instead, the character immediately following the ampersand will be underlined. To choose the menu, a user can press the ALT key and the underlined character at the same time.

Menu Items

Lists the items that appear in the menu.

Item Name

This is the name that appears for the selected item when it is displayed in a menu. The ampersand (&), pound (#), hyphen (-) and tilde (~) characters have special meaning in menu item names.

  • An ampersand causes the next character to appear underlined and act as the access key.
  • The pound character draws an ellipsis (...) after the item.
  • If a hyphen is used as the item name, it causes a separator line to appear in the menu.
  • The tilde character draws a forward slash (/).

Shortcut

You can define a shortcut key for the menu item by selecting a character in this list. The shortcut key is CTRL + the specified character. To avoid conflicts, a shortcut key should be used only once in an application.

Unfocus

This field isn’t available in the Modifier.


Menu Definition window: Buttons

OK

Saves your changes and closes the window.

Cancel

Closes the window without saving changes.


Messages window: Fields

Message ID

Displays the resource ID for this message. When you enter an ID, the corresponding text will be displayed in the Message field.

Message

Displays a message of up to 255 characters.

Replacement markers (the percent symbol followed by a number) are sometimes used in messages to substitute a value for the marker when the message is displayed. For instance, the message "The record for %1 does not exist." could appear as "The record for Ellen Schmidt does not exist." when displayed.


Messages window: Buttons

Browse Buttons

Uses these buttons to quickly go to the first, previous, next or last messages in the dictionary.

Save

Saves the current message and clears the window.

Cancel

Closes the window without saving changes.

Delete

This button is not available when in the Modifier.


Modified Forms window: Fields

Forms list

Displays a list of modified forms in the forms dictionary.


Modified Forms window: Buttons

New

Opens the Select a form to modify window, allowing you to select an original form and create a new copy of that form in the forms dictionary.

Open

Opens the Form Definition window for the selected modified form, allowing you to make additional changes.

Delete

Deletes the selected form from the forms dictionary.


Native Picture Definition window: Fields

Native Picture Name

Displays the name used to store the native picture.

Synchronized With

Allows you to synchronize two native pictures from different operating systems, assigning them the same internal ID. When the data type the synchronized picture is attached to is displayed in the application, the appropriate picture will appear for each operating system.

To synchronize two pictures, save one picture in this window without marking this option. Then, from another operating system, create the corresponding picture and mark the Synchronize With option. A list of pictures that have been created using the first operating system will be displayed. Select the picture from the list, and the Modifier automatically will assign the same ID to both pictures.

Native Picture

Displays the native picture. Use the Paste button to paste an image that you've previously transferred to the Clipboard, or use the Copy button to transfer an existing native picture to the Clipboard.


Native Picture Definition window: Buttons

OK

Saves your entries and closes the window.

Cancel

Clears all new entries and closes the window without saving changes.

Copy

Copies the native picture to the Clipboard, so you can paste it into an external graphics application and edit it.

Paste

Pastes the contents of the Clipboard into the Native Picture area.


Native Pictures window: Fields

Pictures

Displays the list of the native pictures that have been defined for this dictionary.


Native Pictures window: Buttons

New

Opens the Native Picture Definition window, allowing you to add a new picture to the picture library.

Open

Opens the Native Picture Definition window and displays the native picture selected in the list. You can view an existing picture or paste a new picture in the native picture area.

Delete

Removes the selected native picture from the dictionary. You can delete only the native pictures created with the Modifier.


Pattern window: Fields

Patterns

Lists available patterns. The selected pattern will be applied to the background of the selected object. The colors used in the pattern are determined by the object's PatternColor and BackColor properties.

Preview

Displays an example of the selected pattern.


Pattern window: Buttons

OK

Applies the selected pattern and closes the window.

Cancel

Closes the window without selecting a pattern.


Properties window: Fields

Object drop-down list

Allows you to select a window, or fields and text objects in the window. Local fields are preceded by [L] in the list; text objects are preceded by [Text], and the window itself is indicated by the phrase [Window]. Drawn objects (lines, boxes and pictures) aren't included in the list.

Settings box

Allows you to type a value, choose a value from a drop-down list, or open a lookup window. Some properties can't have their values changed.

As an alternative to using the settings box, you can double-click a property in the properties list. Doing so will set the property to the next value in the list, or open the associated lookup window.


Properties window: Buttons

Lookup

The function of this button depends on the type of property being set:

Color properties: Opens the BackColor, FontColor, LineColor or PatternColor window, where you can choose a color.

Datatype property: Opens the Data Type Definition window, allowing you to view the data type for the selected field.

Field property: Opens the Field Definition window or Local Field Definition window, allowing you to view the definition of the selected field.

Pattern property: Opens the Pattern window, where you can choose a pattern to apply to the background of an object.


Resource Lookup window: Fields

Resource list

Displays the list of resources in the dictionary of the type you can select.


Resource Lookup window: Buttons

New

Opens the definition window for the type of resource displayed, allowing you to define a new resource.

Open

Opens the definition window for the selected resource, allowing you to modify the resource.

None

Unmarks the selected resource.

OK

Attaches the selected resource and closes the window.

Cancel

Closes the window without making a selection.


Scrolling Window Layout window: Menus

Tools menu: Mark Small Line Item

This menu item is available only when the Scrolling Window Layout window is open. It sets the minimum space each record will use when the scrolling window is displayed in normal mode. This area is known as the small line item.

Tools menu: Mark Big Line Item

This menu item is available only when the Scrolling Window Layout window is open. It sets the maximum space each record will use when the scrolling window is displayed in expanded mode. This area is known as the big line item.

Tools menu: Link Prompt

This item allows you to link a field to its text prompt. When a field is linked to its prompt, the prompt will be dimmed when the field is disabled. In addition, if the field's Required property is set to true, choosing Show Required Fields from the Help menu will display the linked text with the font color and style as specified in the User Preferences window.

When you choose Link Prompt, the layout window will change to prompt linking mode, until you choose Link Prompt from the menu again. While the window is in prompt linking mode you can link fields to prompts by clicking in a field and dragging the pointer to the text you want to link the field to. A flashing black line will indicate that the link was successful.

Tools menu: Link Lookup

Allows you to link a field to a lookup field (typically a button), and indicate the button will be clicked when Lookup is chosen from the Help menu. Whenever the focus is on the field you linked, the Lookup menu item will be enabled.

When you choose Link Lookup, the layout window will change to lookup linking mode, until you choose Link Lookup from the Tools menu again. While the window is in lookup linking mode you can link fields to lookup buttons by clicking a field and dragging the pointer to the lookup button you want to link the field to. A flashing black line indicates that the link was successful.

Tools menu: Link Format Selector

This item allows you to link a currency or string field to a format field that contains an integer value. The integer value will specify the format applied to the currency or string field. Refer to the topic Linking fields to format fields for more information.

Layout menu: Grid

This menu item activates and inactivates the layout window grid. When the grid is active, a check mark will appear next to this item. All objects added to the layout after the grid has been activated will be aligned to the grid. Using the grid makes it easier to align objects in the layout.

Layout menu: Align To Grid

This menu item aligns any selected objects to the grid.

Layout menu: Show Grid

This menu item displays the grid. You can display the grid when it's active or inactive.

Layout menu: Grid To Back

This menu item places the grid lines behind any objects in the layout area.

Layout menu: Send To Front

This menu item places the selected object in front of any overlapping objects in the layout area. Be sure to verify the window's tab sequence after using this item, since moving an object may change its position in the tab sequence.

Layout menu: Send To Back

This menu item places the selected object behind any overlapping objects in the layout area. Be sure to verify the window's tab sequence after using this item, since moving an object may change its position in the tab sequence.

Layout menu: Set Tab Sequence

This menu item allows you to control where the focus will move to when the user presses TAB in a window. The default tab sequence reflects the order in which the fields were added to the window. Refer to the topic Setting the tab sequence for more information.

Layout menu: Properties

This menu item displays the Properties window, which you can use to set characteristics and attach scripts to a window and its components. The Properties window becomes active when you move the pointer over it.

Layout menu: Toolbox

This menu item displays the Toolbox window, which you can use to place fields and other items in the layout area, and arrange existing items. The Toolbox window becomes active when you move the pointer over it.

Layout menu: Show Field Names

This menu item shows the names associated with each field, rather than the field’s display characteristics.

Layout menu: Show Invisible Fields

This menu items shows fields whose Visible property is set to false. Invisible fields are typically used to store values used by Microsoft Dynamics GP. They aren’t visible when you run Microsoft Dynamics GP.


Window Layout window: Menus

Tools menu: Link Prompt

This item allows you to link a field to its text prompt. When a field is linked to its prompt, the prompt will be dimmed when the field is disabled. In addition, if the field's Required property is set to true, choosing Show Required Fields from the Help menu will display the linked text with the font color and style as specified in the User Preferences window.

When you choose Link Prompt, the layout window will change to prompt linking mode, until you choose Link Prompt from the menu again. While the window is in prompt linking mode you can link fields to prompts by clicking in a field and dragging the pointer to the text you want to link the field to. A flashing black line will indicate that the link was successful.

Tools menu: Link Lookup

Allows you to link a field to a lookup field (typically a button), and indicate the button will be clicked when Lookup is chosen from the Help menu. Whenever the focus is on the field you linked, the Lookup menu item will be enabled.

When you choose Link Lookup, the layout window will change to lookup linking mode, until you choose Link Lookup from the Tools menu again. While the window is in lookup linking mode you can link fields to lookup buttons by clicking a field and dragging the pointer to the lookup button you want to link the field to. A flashing black line indicates that the link was successful.

Tools menu: Link Format Selector

This item allows you to link a currency or string field to a format field that contains an integer value. The integer value will specify the format applied to the currency or string field. Refer to the topic Linking fields to format fields for more information.

Layout menu: Preview

This menu item displays a preview of the current window layout as it will appear in the application. This is only a preview of the visual characteristics of the window; the window will not be functional. When you have finished, close the preview window to return to the layout window.

Layout menu: Grid

This menu item activates and inactivates the layout window grid. When the grid is active, a check mark will appear next to this item. All objects added to the layout after the grid has been activated will be aligned to the grid. Using the grid makes it easier to align objects in the layout.

Layout menu: Align To Grid

This menu item aligns any selected objects to the grid.

Layout menu: Show Grid

This menu item displays the grid. You can display the grid when it's active or inactive.

Layout menu: Grid To Back

This menu item places the grid lines behind any objects in the layout area.

Layout menu: Send To Front

This menu item places the selected object in front of any overlapping objects in the layout area. Be sure to verify the window's tab sequence after using this item, since moving an object may change its position in the tab sequence.

Layout menu: Send To Back

This menu item places the selected object behind any overlapping objects in the layout area. Be sure to verify the window's tab sequence after using this item, since moving an object may change its position in the tab sequence.

Layout menu: Set Tab Sequence

This menu item allows you to control where the focus will move to when the user presses tab in a window. The default tab sequence reflects the order in which the fields were added to the window. Refer to the topic Setting the tab sequence for more information.

Layout menu: Position Window

This menu item allows you to specify where the window will appear on the screen when it opens. When you choose this item, the Position Window window will appear. Move it to the correct opening position and click OK to save the new starting position for your window.

Layout menu: Properties

This menu item displays the Properties window, which you can use to set characteristics and attach scripts to a window and its components. The Properties window becomes active when you move the pointer over it.

Layout menu: Toolbox

This menu item displays the Toolbox window, which you can use to place fields and other items in the layout area, and arrange existing items. The Toolbox window becomes active when you move the pointer over it.

Layout menu: Show Field Names

This menu item shows the names associated with each field, rather than the field’s display characteristics.

Layout menu: Show Invisible Fields

This menu items shows fields whose Visible property is set to false. Invisible fields are typically used to store values used by Microsoft Dynamics GP. They aren’t visible when you run the application.


Select a form to modify window: Fields

Forms

Lists all of the forms in the dictionary.


Select a form to modify window: Buttons

OK

Selects the form and closes the window.

Cancel

Closes the window without selecting a form.


Static Picture Values window: Fields

Pictures

Displays a list of all the pictures in the dictionary.

Static Picture Values

Displays the list of pictures that have been attached to this data type as static picture values.


Static Picture Values window: Buttons

Insert

Inserts the picture selected in the Pictures list into the Static Picture Values list. The picture will be inserted below the item selected in the Static Picture Values list.

Remove

Removes the selected static picture value from the Static Picture Values list.

OK

Closes the window.


Static Text Values window: Fields

New Value

Contains the text you want to add to or use to replace an item in the Static text values list.

Static Text Values

Lists the static text values for the data type.

Sort List

When marked, the items in the Static text values list will be sorted in alphabetical order when they are displayed. (Marking this option doesn't sort the list in the Static Text Values window.) If this option isn't marked, the values will be displayed in the order they appear in the list. The sorting process is not case-sensitive.


Static Text Values window: Buttons

Insert

Inserts the value in the New Value field into the Static Text Values list. The new value will be inserted immediately after the value selected in the list. This button is available only if you are creating a new data type or local field.

Remove

Removes the selected item from the Static Text Values list. This button is available only if you are creating a new data type or local field.

Replace

Replaces the selected item in the Static Text Values list with the text in the New Value field.

OK

Saves your entries and closes the window.

Cancel

Clears all new entries and closes the window without saving changes.


String Definition window: Fields

String

Displays the string you selected in the Strings window. Type the new string in this field, up to 79 characters.


String Definition window: Buttons

OK

Saves the changes and closes the window.

Cancel

Closes the window without saving changes.


Strings window: Fields

Strings

Displays the list of strings that have been defined for this dictionary.

Core

Displays the dictionary core to which the strings in the list belong. In Microsoft Dynamics GP, dictionary cores correspond to series.

When you select a string and change it using the String Definition window, the Modifier will automatically change the string everywhere it occurs in the dictionary, not just within the core that's displayed here. The Core selection simply allows you to view a smaller list of string resources.


Strings window: Buttons

Open

Opens the String Definition window for the selected string, allowing you to modify the current string.

Delete

This button is not available in the Modifier.


Toolbox window: Fields

Field type/Table name

Allows you to choose whether global fields, local fields, or only fields from a table attached to the current form will be displayed in the Fields list.

  • A global field is any field that's displayed in the Field Definition window.
  • A local field is a field created for use with windows in the current form.

To view a list of the global fields that are part of a table attached to the current form, select the table whose fields you want to list.

Fields that appear in tables linked to the form are the same fields as those in the list of global fields. Listing the fields associated with a specific table is simply a shortcut, allowing you to view a smaller list of fields.

Fields list

Displays fields in the table or of the type you chose in the Field type/Table name drop-down list.

To add a field to the layout, use the arrow tool to select a desired field and drag it to the layout area. If you inadvertently drag the wrong field to the layout area, use the arrow tool to select the field in the layout area, then press the DELETE key.

To view the definition of a field, select the field in the fields list and click Open.

Pos

Displays, in pixels, the coordinates of the selected object's upper left and lower right corners relative to the top left corner of the window layout. If the entire window is selected, the position is relative to the top left corner of the screen. This field is automatically updated as you move the selected object in the layout area, allowing you to position an object precisely.

Size

Appears at the bottom of the Toolbox when an object is selected in the layout area. It displays the total width and height, in pixels, of the selected object. This field is automatically updated as you resize the selected object in the layout area, allowing you to use the information displayed to exactly size an object.

Space

Specifies the desired number of pixels between objects arranged with the Tile Vertically or Tile Horizontally tools.


Toolbox window: Buttons

To use a tool on the Layout tab, click the tool's icon, then click in the layout area. To use a tool on the Arrange tab, select the objects you want to align, resize or tile, then click the appropriate tool.

To add and manipulate objects in the layout window, use tools from the Toolbox. The following tools are available:

Tool | Name | Use
 | Arrow tool | Select, resize and move objects in the window layout. Objects highlighted by the arrow tool can be dragged into position in the layout area.
 | Text tool | Add text objects to the layout area. Select the text tool, then click in the appropriate location to type text in the layout.
 | Picture tool | Place pictures from the picture library in the layout area. Select the picture tool, then click the mouse in the desired location in the layout area; the Pictures window will appear. Select a picture and click OK.
 | Line tool | Add lines to the layout area.
 | Shape tool | Add rectangles, circles and other shapes to the layout area.

The toolbox also contains tools you can use to add new fields to a window. Adding new fields is described in the topic Adding New Fields.

Tool | Name | Tool | Name
 | Push button tool |  | Drop-down list tool
 | Combo box tool |  | List box tool
 | Multi-select list tool |  | Big text tool
 | String tool |  | Integer tool
 | Currency tool |  | Date tool
 | Time tool |  | Visual switch tool
 | Horizontal list box tool |  | Radio group tool
 | Radio button tool |  | Check box tool
 | Progress indicator tool |  |

Clicking the Arrange tab in the Toolbox displays an additional set of tools used to align, resize or tile fields in the window. These tools are described in the following table.

Category | Tool | Name | Use
Align |  | Align to Top | Aligns the selected objects with the top object in the group.
 |  | Align to Left | Aligns the selected objects with the leftmost object in the group.
 |  | Align to Right | Aligns the selected objects with the rightmost object in the group.
 |  | Align to Bottom | Aligns the selected objects with the bottom object in the group.
Size |  | Size to Shortest | Shrinks the selected objects to the height of the shortest object in the group.
 |  | Size to Narrowest | Shrinks the selected objects to the width of the narrowest object in the group.
 |  | Size to Widest | Enlarges the selected objects to the width of the widest object in the group.
 |  | Size to Tallest | Enlarges the selected objects to the height of the tallest object in the group.
 |  | Size to Default | Resizes the field to its default size, based upon how the visual properties for the field are set.
Tile |  | Tile Horizontally | Tiles the selected objects horizontally. The value in the Space field specifies the space between objects.
 |  | Tile Vertically | Tiles the selected objects vertically. The value in the Space field specifies the space between objects.


Button Items window: Buttons

OK

Saves your entries and closes the window.

Cancel

Closes the window without saving changes.